/*na vstupe su 2 polia ktore treba vytvorit v hlavnom programe
  ak priama FFT tak smer=1,ak inverzna -1                   */
#include <stdio.h>
#include <math.h>
#include "simul.h"

extern d2prevrat();
/*--------------------------------------------------------------------------------------------------------------*/
Yfourier(rea,img,vx,vy,smer)
	  float *rea[],*img[];
	  int vx,vy,smer;
{int i,j,p,s,step,k,N=vy;
 float msn[D1MAX],cs[D1MAX], pmr,pmi;
 if(smer== -1)
   { d2prevrat(rea,vx,vy,1);
	 d2prevrat(img,vx,vy,1);
	}
 for(i=0;i<vy/2;i++)
   { msn[i]= sin(M_PI*(double)i*2/vy);
	 cs[i]= cos(M_PI*(double)i*2/vy);
	 }
 biy(rea,vx,vy);
 biy(img,vx,vy);
 for(j=0;j<vx;j++)
   {p=1;
    while(p<N){ s=0;
	        step=N/2/p;
		while(s<N){for(i=s,k=0;i<s+p;i++,k+=step)
		            {pmr= *(rea[i+p]+j)*cs[k]+ *(img[i+p]+j)*msn[k];
			     pmi= *(img[i+p]+j)*cs[k]-*(rea[i+p]+j)*msn[k];
			     *(rea[i+p]+j)= *(rea[i]+j)-pmr;
			     *(img[i+p]+j)= *(img[i]+j)-pmi;
			     *(rea[i]+j)+=pmr;
			     *(img[i]+j)+=pmi;}
		           s+=2*p;}
		p*=2;}
   }
 }
/*------------------------------------------------------------------------------------------------------------*/
Xfourier(rea,img,vx,vy,smer)
	  float *rea[],*img[];
	  int vx,vy,smer;
{int i,j,p,s,step,k,N=vx;
 float msn[D1MAX],cs[D1MAX],vymena,pmr,pmi;
 if(smer== -1)
   { d2prevrat(rea,vx,vy,0);
	 d2prevrat(img,vx,vy,0);
	 }
 for(i=0;i<vx/2;i++)
   { msn[i]= sin(M_PI*(double)i*2/vx);
	 cs[i]= cos(M_PI*(double)i*2/vx);
	 }
 bix(rea,vx,vy);
 bix(img,vx,vy);
 for(j=0;j<vy;j++)
   {p=1;
	while(p<N){s=0;
		   step=N/2/p;
		   while(s<N){for(i=s,k=0;i<s+p;i++,k+=step)
				{pmr= *(rea[j]+i+p)*cs[k]+ *(img[j]+i+p)*msn[k];
				 pmi= *(img[j]+i+p)*cs[k]- *(rea[j]+i+p)*msn[k];
				 *(rea[j]+i+p)= *(rea[j]+i)-pmr;
				 *(img[j]+i+p)= *(img[j]+i)-pmi;
				 *(rea[j]+i)+=pmr;
				 *(img[j]+i)+=pmi;}
			      s+=2*p;}
		   p*=2;}
   }
 }
/*--------------------------------------------------------------------------------------------------------------------*/
 fsp_do(s,re,im,vx,vy)
	float *s[],*re[],*im[];
	unsigned int vx,vy;
  {int i,j;
   *(s[0]+0)= *(re[0]+0);
   for(j=1;j<vx;j++) *(s[0]+j)=j%2 ? *(re[0]+j/2+1):*(im[0]+j/2);
   for(i=1;i<vy;i++) *(s[i]+0)=i%2 ? *(re[i/2+1]+0):*(im[i/2]+0);
   for(i=1;i<vy;i++) if(i%2) {for(j=1;j<vx;j++) *(s[i]+j)= j%2 ? *(re[i/2+1]+j/2+1):*(re[i/2+1]+vx-j/2);}
					   else  {for(j=1;j<vx;j++) *(s[i]+j)= j%2 ? *(im[i/2]+j/2+1):*(im[i/2]+vx-j/2);}
	for(j=1;j<vx;j++) *(s[vy-1]+j)=j%2 ? *(re[vy/2]+j/2+1):*(im[vy/2]+j/2);
   }
/*--------------------------------------------------------------------------------------------------------------------*/
 dopln_1r(d,vx,vy,druh)
	float *d[];
	int vx,vy,druh;
 {int j;for(j=1;j<vx/2;j++) *(d[0]+vx-j)= *(d[0]+j) * druh;}
/*--------------------------------------------------------------------------------------------------------------------*/
dopln_s(d,vx,vy,druh)
	float *d[];
	int vx,vy,druh;
 {int i;for(i=1;i<vy/2;i++) *(d[vy-i]+0)= *(d[i]+0) * druh;}
/*--------------------------------------------------------------------------------------------------------------------*/
dopln_pole(d,vx,vy,druh)
	float *d[];
	int vx,vy,druh;
{int i,j,c=0,kon=(vx-1)*(vy-1);
 for(i=1;i<vy && c<kon;i++)for(j=1;j<vx && c<kon ;j++){*(d[vy-i]+vx-j)= *(d[i]+j) * druh;c++;}
 }
/*--------------------------------------------------------------------------------------------------------------------*/
 fsp_zo(s,re,im,vx,vy)
	float *s[],*re[],*im[];
	unsigned int vx,vy;
  {int i,j;
   *(re[0]+0)= *(s[0]+0);
   for(j=1;j<vx;j++) if(j%2){*(re[0]+j/2+1)= *(s[0]+j);}else *(im[0]+j/2)= *(s[0]+j);
   for(i=1;i<vy;i++) if(i%2){*(re[i/2+1]+0)= *(s[i]+0);}else *(im[i/2]+0)= *(s[i]+0);
   for(i=1;i<vy;i++) if(i%2){for(j=1;j<vx;j++) if(j%2){*(re[i/2+1]+j/2+1)= *(s[i]+j);}else *(re[i/2+1]+vx-j/2)= *(s[i]+j);}
					   else  {for(j=1;j<vx;j++) if(j%2){*(im[i/2]+j/2+1)= *(s[i]+j);}else *(im[i/2]+vx-j/2)= *(s[i]+j);}
	for(j=1;j<vx;j++)if(j%2){*(re[vy/2]+j/2+1)= *(s[vy-1]+j);}else *(im[vy/2]+j/2)= *(s[vy-1]+j);
	dopln_1r(re,vx,vy,1);dopln_s(re,vx,vy,1);dopln_pole(re,vx,vy,1);
	dopln_1r(im,vx,vy,-1);dopln_s(im,vx,vy,-1);dopln_pole(im,vx,vy,-1);
	}