#include "simul.h"
/*--------------------------------------------------------------------------------------*/
ddx(rea,img,vx,vy)
   float *rea[],*img[];
   int vx,vy;
{int i,j;Xfourier(rea,img,vx,vy,1);
for(i=0;i<vy;i++) for(j=0;j<vx;j++) *(rea[i]+j)= *(rea[i]+j)- *(img[i]+j);nuluj(img,vx,vy);}
/*--------------------------------------------------------------------------------------*/
ddy(rea,img,vx,vy)
   float *rea[],*img[]; 
   int vx,vy;
{int i,j;Yfourier(rea,img,vx,vy,1);
for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(rea[i]+j)= *(rea[i]+j)- *(img[i]+j);nuluj(img,vx,vy);}
/*--------------------------------------------------------------------------------------*/
iddx(rea,img,vx,vy)
   float *rea[],*img[]; 
   int vx,vy;
{static float pom1[D1MAX],pom2[D1MAX];
 int i,j;
 for(i=0;i<vy;i++){ for(j=1;j<vx;j++) {pom1[j]= *(rea[i]+vx-j)+ *(rea[i]+j);
									  pom2[j]= *(rea[i]+vx-j)- *(rea[i]+j);}
				  for(j=1;j<vx;j++) {*(rea[i]+j)= pom1[j]/2;
									 *(img[i]+j)= pom2[j]/2;}
				  }
 Xfourier(rea,img,vx,vy,-1);}
/*--------------------------------------------------------------------------------------*/
iddy(rea,img,vx,vy)
   float *rea[],*img[];
   int vx,vy;
{static float pom1[D1MAX],pom2[D1MAX];
 int i,j;
 for(j=0;j<vx;j++){ for(i=1;i<vy;i++) {pom1[i]= *(rea[vy-i]+j)+ *(rea[i]+j);
                                       pom2[i]= *(rea[vy-i]+j)- *(rea[i]+j);}
                  for(i=1;i<vy;i++) {*(rea[i]+j)= pom1[i]/2;
                                     *(img[i]+j)= pom2[i]/2;}
                  }
 Yfourier(rea,img,vx,vy,-1);}
/*--------------------------------------------------------------------------------------*/
dddox(d,vx,vy)
   float *d[];
   int vx,vy;
{int i,j;
  static float pom[D1MAX]; 
  for(i=0;i<vy;i++){for(j=1;j<vx;j++)pom[j]= (j%2) ? *(d[i]+j/2+1) : *(d[i]+vx-j/2);
                   for(j=1;j<vx;j++) *(d[i]+j)=pom[j];}
 }
 /*--------------------------------------------------------------------------------------*/
dddoy(d,vx,vy)
   float *d[];
   int vx,vy;
{int i,j;
  static float pom[D1MAX];
  for(j=0;j<vx;j++){for(i=1;i<vy;i++)pom[i]= (i%2) ? *(d[i/2+1]+j) : *(d[vy-i/2]+j);
                   for(i=1;i<vy;i++) *(d[i]+j)=pom[i];}
 }
 
/*--------------------------------------------------------------------------------------*/
ddzox(d,vx,vy)
   float *d[];
   int vx,vy;
{int i,j;
  static float pom[D1MAX];
  for(i=0;i<vy;i++){for(j=1;j<vx;j++) pom[j]= *(d[i]+j);
				   for(j=1;j<vx;j++)if(j%2){*(d[i]+j/2+1)=pom[j];}else *(d[i]+vx-j/2)=pom[j];}
 }
/*--------------------------------------------------------------------------------------*/
ddzoy(d,vx,vy)
   float *d[];
   int vx,vy;
{int i,j;
  static float pom[D1MAX];
  for(j=0;j<vx;j++){for(i=1;i<vy;i++) pom[i]= *(d[i]+j);
                   for(i=1;i<vy;i++)if(i%2){*(d[i/2+1]+j)=pom[i];}else *(d[vy-i/2]+j)=pom[i];}                 
 }
