#include <stdio.h>
#include "simul.h"
float *mf[YMAX+1];
int xp,yp;
/*-----------------------------------------------------------------------------------*/
/* Nacita maticu z daneho suboru do pola, pricom ich uklada na definovane miesta      */
zosuboru(d,vx,vy)
float *d[];
int vx,vy;
{FILE *vstup;
 char *subor=nlq.mname;
 float cislo;
 int i=0,j=0,pocet=0;
 if(!(vstup = fopen(subor,"r")))
   {printf("!!!!! Neviem najst subor s maticou !!!!!\n");exit(1);};
  while((fscanf(vstup,"%f",&cislo)!=EOF)&&(pocet< nlq.vx*nlq.vy))
   {*(d[i]+j)=cislo;
    pocet++;j+=xp;
    if(j==vx){j=0;i+=yp;}
     }
 if(nlq.vx*nlq.vy!=pocet)
   {printf("Malo prvkov v matici (%d)\n");
    exit(1);
     };
  fclose(vstup);
 }
/*-----------------------------------------------------------------------------------*/
/* Vyrobi maticu ako HP filter, upravi jsm zlozku a prenos(rastie od 0 po 1 na <min,max>)*/
rucne(d,vx,vy)
float *d[];
int vx,vy;
{int i,j,a=0,b=0,pocet=0;
 int max=nlq.max,min=nlq.min;
 float prvok;
 if (max==min)max++;
 printf(" %d %d \n",min,max);
 for(i=0;i<nlq.vx;i++)
   for(j=0;j<nlq.vy;j++)
      {  if((i+j)>=max) prvok=1.0;
         else{ if((i+j)<=min) prvok =0.0;
               else prvok=(float)(i+j-min)/(max-min);
              };
       *(d[a]+b)=prvok;
       pocet++;b+=xp;
       if(b==vx){b=0;a+=yp;}
       }
 *(d[0]+0)=nlq.jsm; 
  }
/*-----------------------------------------------------------------------------------*/
minit(vx,vy)
 int vx,vy;
{ int i,j,pocet,a,b;
  vytvor(mf,vx+1,vy+1);
  i=0,j=0;xp=vx/nlq.vx;yp=vy/nlq.vy;
  if(nlq.sposob==0)zosuboru(mf,vx,vy);
  else rucne(mf,vx,vy);
 
printf("Maticu upravujem na velkost %dx%d\n",vx,vy);
if(yp>0 && xp>0)
  {/* maticu bude natahovat len ked treba */
   for(i=0;i<vy;i+=yp)
     for(a=0;a<vx;a+=xp)
	{if(a==(vx-xp))*(mf[i]+vx)=(*(mf[i]+a)- *(mf[i]+a-2*xp))/2 + *(mf[i]+a);
	 for(b=0;b<xp;b++)
	   *(mf[i]+a+b)=(*(mf[i]+a+xp)- *(mf[i]+a))/xp*b + *(mf[i]+a);
	 }
   for(i=0;i<vx;i++)
     for(a=0;a<vy;a+=yp)
	{if(a==(vy-yp))*(mf[vy]+i)=(*(mf[a]+i)- *(mf[a-2*yp]+i))/2 + *(mf[a]+i);
	 for(b=0;b<yp;b++)
	   *(mf[a+b]+i)=(*(mf[a+yp]+i)- *(mf[a]+i))/yp*b + *(mf[a]+i);
	 }
    }
  
 if(nlq.mtr)
	mtrafo(vx,vy);
 if(proc.spec)vypismatrix(mf,vx,vy,"mat");
 }
/*-----------------------------------------------------------------------------------*/
mkvant(d,vx,vy)
float *d[];
int vx,vy;
{int i,j;
for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j)/= *(mf[i]+j);
}
/*-----------------------------------------------------------------------------------*/
mdekvant(d,vx,vy)
float *d[];
int vx,vy;
{int i,j;
for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j)*= *(mf[i]+j);
}
/*-----------------------------------------------------------------------------------*/
invert(d,vx,vy)
float *d[];
int vx,vy;
{int i,j;
for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j) =  1 / *(d[i]+j);
}
/*-----------------------------------------------------------------------------------*/
mabs(d,vx,vy)
float *d[];
int vx,vy;
{int i,j;
for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j) = fabs(*(d[i]+j));
}
/*-----------------------------------------------------------------------------------*/
mtrafo(bx,by)
int bx,by;
{int a,b,jeim=0,jesp=0;
  float *imag[512];
  float *sp[512];
  float mocnina,abs_val;
 printf("-----------------------------------\n");
 printf("robim transformaciu kvant. matice \n");
 switch(trdef.txnum){   case(THY) :
                        case(THYP):
                        case(TF)  :vytvor(imag,bx,by);nuluj(imag,bx,by);jeim=1;break;
			case(TFP) :vytvor(imag,bx,by);vytvor(sp,bx,by);jeim=1;
				   nuluj(imag,bx,by);nuluj(sp,bx,by);jesp=1;break;
			}
switch(trdef.tynum){    case(THY) :
                        case(THYP):
		        case(TF)  :if(!jeim){vytvor(imag,bx,by);nuluj(imag,bx,by);}break;
			case(TFP) :if(!jeim){vytvor(imag,bx,by);nuluj(imag,bx,by);};
                                   if(!jesp){vytvor(sp,bx,by);nuluj(sp,bx,by);}break;
			}

 invert(mf,bx,by);
 printf("SPATNU \n");
 Ycos(mf,bx,by,-1);
 Xcos(mf,bx,by,-1);
 printf("Priamu v smere X\n");
 switch(trdef.txnum){ 	case(TSH) :whx(mf,bx,by);xslant(mf,bx,by,1);break;
			case(TSP) :whx(mf,bx,by);xslant(mf,bx,by,1);bix(mf,bx,by);break;
                        case(TSS) :whx(mf,bx,by);xslant(mf,bx,by,1);bix(mf,bx,by);gix(mf,bx,by,1);break;
                        case(THY) :ddx(mf,imag,bx,by);break;
                        case(THYP):ddx(mf,imag,bx,by);dddox(mf,bx,by);break;
			case(TF)  :
			case(TFP) :Xfourier(mf,imag,bx,by,1);break;
			case(THA) :haarx(mf,bx,by,1);break;
			case(TWH) :whx(mf,bx,by);break;
		        case(TWP) :whx(mf,bx,by);bix(mf,bx,by);break;
			case(TWS) :whx(mf,bx,by);bix(mf,bx,by);gix(mf,bx,by,1);break;
			case(TCOS):Xcos(mf,bx,by,1);break;
			default  :printf("-->nespravena");
                        }
 printf("Priamu v smere Y \n");
 switch(trdef.tynum){ 	case(TSH) :why(mf,bx,by);yslant(mf,bx,by,1);break;
			case(TSP) :why(mf,bx,by);yslant(mf,bx,by,1);biy(mf,bx,by);break;
                        case(TSS) :why(mf,bx,by);yslant(mf,bx,by,1);biy(mf,bx,by);giy(mf,bx,by,1);break;
			case(THY) :ddy(mf,imag,bx,by);dddoy(mf,bx,by);break;
                        case(THYP):ddy(mf,imag,bx,by);dddoy(mf,bx,by);break;
			case(TF)  :
			case(TFP) :Yfourier(mf,imag,bx,by,1);break;
			case(THA) :haary(mf,bx,by,1);break;
			case(TWH) :why(mf,bx,by);break;
			case(TWP) :why(mf,bx,by);biy(mf,bx,by);break;
			case(TWS) :why(mf,bx,by);biy(mf,bx,by);giy(mf,bx,by,1);break;
			case(TCOS):Ycos(mf,bx,by,1);break;
		        default   :printf("--> nespravena\n");
			}
 switch(trdef.txnum){   case(TF)  :
		        case(TFP) :printf("Uprava I\n");
				   for(a=0;a<by;a++)
				     for(b=0;b<bx;b++)
					{mocnina= ( *(mf[a]+b) * *(mf[a]+b) +
					 *(imag[a]+b) * *(imag[a]+b) );
					 abs_val=(float)sqrt(mocnina);
					 *(mf[a]+b)= *(imag[a]+b) = abs_val;
					 }
				   break;
			}
 switch(trdef.txnum){   case(TFP):printf("UPRAVA II \n");
			   fsp_do(sp,mf,imag,bx,by);
			   for(a=0;a<by;a++)
				for(b=0;b<bx;b++)
				  *(mf[a]+b)= *(sp[a]+b);
			    break;
		 }
 divide(mf,bx,by);
 invert(mf,bx,by);
 mabs(mf,bx,by);
 if(jeim)vymaz(imag,bx,by);
 if(jesp)vymaz(sp,bx,by);
 }


