#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include "simul.h"

void klavesa();
/*********************************************************************/
MAX(a,b)
 float *a,b;
{if(b> *a) *a=b;}
/*********************************************************************/
MIN(a,b)
 float *a,b;
{if(b< *a) *a=b;}
/*********************************************************************/
save_compress()
{char subor[NLEN];
 if(comp.rob)
   {sprintf(subor,"out%s%s.cmp",trdef.txabr,trdef.tyabr);
    pis_bit_subor(comp.buf,comp.ptr,subor);
    };
  }
/*********************************************************************/
all_dealloc()
{int a;
 for(a=0;a<bl.numb;a++)
   free(bl.data[a]);
 free(comp.buf);
 }
/*********************************************************************/
rob_hlavicku(analyza)
FILE *analyza;
{/*  bla bla bla obrazok, velkost ...*/
 fprintf(analyza," - ------------------------------------------------\n");
  fprintf(analyza,"|                  Vystupne informacie            |\n");
  fprintf(analyza," ------------------------------------------------- \n\n");
  fprintf(analyza,"Vstupny obrazok je subor '%s'\n",sim.vstup);
  fprintf(analyza,"Transformacne pole je velke X=%d  *  Y=%d  pixelov \n",
                   sim.ox,sim.oy);
  if(comp.rob)
   {if(pred.ziv||pred.rl)fprintf(analyza,"Pouzite bolo CTC kodovanie :");
    if(pred.ziv)
     {fprintf(analyza,"Ziv-Lempel, kodovanych bitovych \n");
      fprintf(analyza,"rovin: %d , presun: %d bit/byte\n",
              pred.ziv_rov,pred.ziv_biby);
      }
    if(pred.rl)
     {fprintf(analyza,"RL+Huffman pre hornu bit.rovinu\n");
      fprintf(analyza,"velkost RL bloku: 2^%d bitov a \n",pred.rl_sl);
      fprintf(analyza,"vzorka pre huffmanov kod: %d bitov \n",pred.rl_huf);
      } 
    }
  if(pred.log)
    fprintf(analyza,"Data pred tranfsormaciou logaritmujem \n");
  if(nlq.ako)
    {fprintf(analyza,"Robilo sa nelinearne kvantovaie maticou %s\n",nlq.mname);
     if(nlq.mtr)fprintf(analyza,"pricom tato sa najprv transformovala \n");
     }
  fprintf(analyza,"Sposob nacitavania spektr.zloziek: ");
  switch(rez.typ)
    {case(0):fprintf(analyza,"cik-cak\n");break;
     case(1):fprintf(analyza,"rovno\n");break;
     case(2):fprintf(analyza,"uzivatelskou maticou '%s'\n",rez.m2name);
     }
  fprintf(analyza,"Zastavenie orezavania:");
  switch(rez.method)
    {case(0):fprintf(analyza," orezanie x %% spekt. zloziek\n");break;
     case(1):fprintf(analyza," orezanie x %% energie spekt.zloziek\n");break;
     case(2):fprintf(analyza," zastavi na x-tom nenulovom spekt. koef.\n");break;
     } 
  if(oberg.robit)fprintf(analyza,"Orezanu energiu obnovujem\n");
  fprintf(analyza,"\n"); 
  }
/*********************************************************************/
inicomp_tam()
{ /*pripisanie globalnych charakteristik, procedury si uz svoje vlastne pripisu sami*/
  if(comp.rob)
	{comp.buf=(unsigned char *)calloc( CMPMAX,1);
         comp.ptr=0;
  printf("ZAPIS-GLOBALNE: ox %d oy %d trx %d try %d numb %d btyp %d bx %d by %d \n",
          sim.ox,sim.oy,trdef.txnum,trdef.tynum,bl.numb,bl.type,bl.bx,bl.by);
 
	 pripis((long)sim.ox,16);pripis((long)sim.oy,16);
	 pripis((long)trdef.txnum,8);pripis((long)trdef.tynum,8);
	 pripis((long)bl.numb,16);pripis((long)bl.bx,16);pripis((long)bl.by,16);
	 pripis((long)rez.typ,2);pripis((long)oberg.robit,1);
	 pripis((long)nlq.ako,2);pripis((long)nlq.mtr,1);
         pripis((long)pred.log,1);
	 pripis((long)pred.ziv,1);
         pripis((long)pred.rl,1);
         }
 }
/*********************************************************************/
inicomp_spat()
{ cit_bit_subor(&(comp.buf),comp.subor);
  comp.ptr=0;
  sim.ox=(int)odpis(16);sim.oy=(int)odpis(16);
  trdef.txnum=(int)odpis(8);trdef.tynum=(int)odpis(8);
  bl.numb=(int)odpis(16);bl.bx=(int)odpis(16);bl.by=(int)odpis(16);
  rez.typ=(int)odpis(2);oberg.robit=(int)odpis(1);
  nlq.ako=(int)odpis(2);nlq.mtr=(int)odpis(1);
  pred.log=(int)odpis(1);
  pred.ziv=(int)odpis(1);
  pred.rl=(int)odpis(1);
  if(nlq.ako==1)
    {printf("Zadaj meno suboru s kvant. maticou: \n");
     scanf("%s",nlq.mname);
     }
  if(rez.typ==2)
    {printf("Zadaj meno suboru s nacitavacou. maticou: \n");
     scanf("%s",rez.m2name);
     }
  printf("GLOBALNE: ox %d oy %d trx %d try %d numb %d btyp %d bx %d by %d \n",
          sim.ox,sim.oy,trdef.txnum,trdef.tynum,bl.numb,bl.type,bl.bx,bl.by);
  printf("rez.typ %d oberg.robit %d qnt.ako %d qnt.mtr %d pred.ziv %d pred.rl %d\n",
	  rez.typ,oberg.robit,nlq.ako,nlq.mtr,pred.ziv,pred.rl);
  initrez();
  initmethod();
 }
/*-------------------------------------------------------------------*/
pisfloat(cislo)
float cislo;
{int count;
 unsigned char *pbajt,bajt;
 void *vsetko;
 float localflo=cislo;
 pbajt = vsetko = & localflo;
  for(count=0;count< sizeof(float);count++)
	{bajt = * pbajt;
	 pripis((long)bajt,8);
	 pbajt++;
	  }
 }

/*-------------------------------------------------------------------*/
citajfloat(cislo)
float *cislo;
{float localflo;
 unsigned char by,*pby;
 void *vsetko;
 int count;
 pby=vsetko= &localflo;
 for(count=0;count<sizeof(float);count++)
   {by= (unsigned char) odpis(8);
	*pby = by ;
	pby ++;
	}
 *cislo=localflo;
}
/*###################################################################*/
 pripis(slovo,dlzka)
 unsigned long slovo;
 unsigned char dlzka;
{ unsigned long maska=1;
  if(comp.rob)
     {maska=maska<<(dlzka-1);
	while(maska)
          {if(maska & slovo)
             *(comp.buf+comp.ptr/8)+=1<<(comp.ptr%8);
	   comp.ptr++;
	   maska/=2;
	   }
     }
 }
/*###################################################################*/
bitcopy(inbuf,inptr,outbuf,outptr,numbit)
unsigned char *inbuf,*outbuf;
long numbit,*inptr,*outptr;
{long myin= *inptr,myout= *outptr;
 printf("bitcopy z pos %d na pos %d pocet %d \n",myin,myout,numbit);
 while(numbit>0)
   {if( (1<<(myin%8)) & *(inbuf+myin/8) )
      *(outbuf+myout/8)= *(outbuf+myout/8) | (1<<(myout%8));
    else *(outbuf+myout/8)= *(outbuf+myout/8) & (255-(1<<(myout%8)));
    myin++;myout++;numbit--;
    }
 *inptr=myin;
 *outptr=myout;
 }
/*###################################################################*/
odpis(dlzka)
   unsigned char dlzka;
{long slovo;
 unsigned long maska=1;
 maska=maska<<(dlzka-1);
 slovo=0;
 while(maska){if(*(comp.buf+comp.ptr/8) & 1<<(comp.ptr%8)){slovo+=maska;};
			  comp.ptr++;
			  maska/=2;
			 }
return(slovo);
}
/*###################################################################*/
ukazdata()
{int i,j;
 for(i=0;i<bl.numb;i++)
   {printf("blok %d ma %d prvkov :\n",i,bl.ldata[i]);
	for(j=0;j<bl.ldata[i];j++)
	 printf("%d.p=%d ",j,*(bl.data[i]+j));
	printf("\n");
	}
 }
/*-------------------------------------------------------------------*/
getbxby(blk,bx,by)
int *blk,*bx,*by;
{*bx= bl.bx;
 *by= bl.by;
 }
/*-------------------------------------------------------------------*/
blget(blk,d,b,sizex,sizey)
float *d[],*b[];
int blk,*sizex,*sizey;
{int i,posx,posy;
 *sizex=bl.bx;*sizey=bl.by;
 posx=(blk*bl.bx)%sim.ox;posy=(blk*bl.bx)/sim.ox*bl.by;
 for(i=0;i<bl.by;i++) b[i]= d[i+posy]+posx;
}
/*-------------------------------------------------------------------*/
blput(blk,d,b,sizex,sizey)
float *d[],*b[];
int blk,sizex,sizey;
{int i,j,posx,posy;
 posx=(blk*bl.bx)%sim.ox;posy=(blk*bl.bx)/sim.ox*bl.by;
 for(i=0;i<sizey;i++)
   for(j=0;j<sizex;j++)
	  *(d[i+posy]+j+posx)= *(b[i]+j);
}

/*-------------------------------------------------------------------*/
 blputjsm(blk,d,hod)
int blk;
float *d[];
float hod;
{ int posx=(blk*bl.bx)%sim.ox,posy=(blk*bl.bx)/sim.ox*bl.by;
  *(d[posy]+posx)=hod;
   }
/*-------------------------------------------------------------------*/
 float blgetjsm(blk,d)
float *d[];
int blk;
{ int posx=(blk*bl.bx)%sim.ox,posy=(blk*bl.bx)/sim.ox*bl.by;
  return(*(d[posy]+posx));
}
/*-------------------------------------------------------------------*/
float MSE(d,vx,vy,subor)
float *d[];
char *subor;
int vx,vy;
{float *ref[D1MAX],mse=0;
 int i,j;
  printf("Pocitam mse dat oproti: %s\n",subor);
 vytvor(ref,vx,vy);
 nacitaj(ref,vx,vy,subor);
 for(i=0;i<vy;i++)for(j=0;j<vx;j++)
		mse=mse+ (*(d[i]+j)- *(ref[i]+j)) * (*(d[i]+j)- *(ref[i]+j));
 mse=mse/((float)vx*vy);
 vymaz(ref,vx,vy);
 printf(">>>>>>>>>>>>>>>  MSE je %f  <<<<<<<<<<<<<<<\n",mse);
 sim.Mse=mse;
 }
/*-------------------------------------------------------------------*/
dpis(databuf,dataptr,robit)
 unsigned short int *databuf,robit;
 unsigned long dataptr;
{long dac;if (robit)
		   {printf("datove pole ma %d prvkov a je taketo:\n",dataptr);
			for(dac=0;dac<dataptr;dac++) printf(" %d",*(databuf+dac));printf("\n");
			}
 }

/*-------------------------------------------------------------------*/
 nuluj(d,vx,vy)
	float *d[];
	unsigned int vx,vy;
{int i,j;for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j)= 0;}
/*###################################################################*/
int pocbit(hodnota)
	long hodnota;
{if(hodnota){return(ceil(log((float)hodnota)/log(2.0)));}
 else return(0);
 }
/*-------------------------------------------------------------------*/
pis(d,vx,vy,k)
	float *d[];
	int vx,vy,k;
   {int i,j;printf("\n");
	if(k==1){for(i=0;i<vy;i++)
			{for(j=0;j<vx;j++) printf("%9f ", *(d[i]+j));
			 printf("\n");}
		  printf("\n");}
	klavesa();
	}
/*-------------------------------------------------------------------*/
   vytvor(d,vx,vy)
	float *d[];
	int vx,vy;
  {int  i;
  /*printf("alokujem %d bytov ... ",vx*vy*sizeof(float));*/
  for(i=0;i<vy;i++)if(!(d[i] =( float * ) calloc(vx,sizeof(float))))
						{printf("nada sa alokovat pamaat\n");exit(1);};
   /*printf("OK\n");*/
  }
/*-------------------------------------------------------------------*/
   vymaz(d,vx,vy)
	float *d[];
	int vx,vy;
  {int  i;
   /*printf("nicim pole %d bytov ... ",vx*vy*sizeof(float));*/
  for(i=0;i<vy;i++)free(d[i]); 
  /*printf("OK\n");*/
  }
/*-------------------------------------------------------------------*/
void klavesa()
{char znak;
   printf("Cakam na stlacenie klavesy(ak to teraz breaknes, napis 'tset' )\n");
   system("stty cbreak -echo");
   znak=getchar();
   system("stty -cbreak echo");
 }
/*-------------------------------------------------------------------*/
  znic()
{int i;
 klavesa();
 for(i=0;i<proc.poc_proc;i++)
	{kill(proc.pid[i],1);
	 printf("proces %d s id %d zniceny\n",i,proc.pid[i]);
	 }
 proc.poc_proc=0;
 }
/*-------------------------------------------------------------------*/
manzadaj(d,vx,vy,comment)
 float *d[];
 int vx,vy;
 char *comment;
{int i,j;
 printf("Zadaj pole %dx%d (po riadkoch) typu:%s\n",vy,vx,comment);
 for(i=0;i<vy;i++)
  for(j=0;j<vx;j++)
   {printf("Zadaj prvok (%d,%d): ",i+1,j+1);fflush(stdout);
    scanf("%f",(d[i]+j));
    }
 manpis(d,vx,vy,"zadane pole");
 }
/*-------------------------------------------------------------------*/
manpis(d,vx,vy,comment)
 float *d[];
 int vx,vy;
 char *comment;
{int i,j;
 printf("Pole %dx%d :%s \n",vy,vx,comment);
 for(i=0;i<vy;i++)
  {for(j=0;j<vx;j++) printf("%9f ", *(d[i]+j));
   printf("\n");
   }
 klavesa();
 }