#include "simul.h"
/*-----------------------------------------------------------------*/
/* Ocisluje pole "pole" podla pravidla inverzie bitov              */
  prehod(pole,pocet)
	 int *pole,pocet;
	 {int i,j,n;
	  for(i=0;i<pocet;i++)
		{pole[i] =0;n=i;
		 for(j=pocet;j>1;j/=2)
		   {pole[i]=2*pole[i]+n%2;n/=2;
			}
		 }
           }
/*-----------------------------------------------------------------------*/
void graycode(pole,size,smer)
int pole[];
int size,smer;
{int step=size,pos,a,fill;
 int pom[D1MAX];
 for(a=0;a<size;a++)
   pole[a]=0;
 while(step>1)
   {pos=step/2;
	while(pos<size)
	  {if(step==size)fill=step/2;
	   else          fill=step;
	   for(a=0;a<fill;a++,pos++)
		 pole[pos]+=step/2;
	   pos+=step;
	   }
	step/=2;
	}
if(smer==-1)
  {for(a=0;a<size;a++)
	 pom[pole[a]]=a;
   for(a=0;a<size;a++)
	 pole[a]=pom[a];
   }
 }	  
/*-----------------------------------------------------------------------*/
void  gix(d,vx,vy,smer)
	 float *d[];
	 unsigned int vx,vy;
	 int smer;
	{int i,j,inv[D1MAX];
	 float pom[D1MAX];
         graycode(inv,vx,smer);
	 for(i=0;i<vy;i++){for(j=0;j<vx;j++) pom[j]= *(d[i]+inv[j]);
					   for(j=0;j<vx;j++) *(d[i]+j)=pom[j];}
	 
          }
/*-----------------------------------------------------------------------*/
void  giy(d,vx,vy,smer)
	 float *d[];
	 unsigned int vx,vy;
	 int smer;
	{int i,j,inv[D1MAX];
	 float pom[D1MAX];
	 graycode(inv,vy,smer);
	 for(j=0;j<vx;j++){for(i=0;i<vy;i++) pom[i]= *(d[inv[i]]+j);
					   for(i=0;i<vy;i++) *(d[i]+j)=pom[i];}
	 
         }

/*-----------------------------------------------------------------*/
/* podla bitovo invertovaneho pola preskupuje datove pole          */
bitinv(pole,inv,N)
   float *pole;
   int *inv,N;
{static float pom[D1MAX];
 int j;
	 for(j=0;j<N;j++) pom[j]= *(pole+inv[j]);
	 for(j=0;j<N;j++) *(pole+j)=pom[j];
	 }
/*-----------------------------------------------------------------*/
/* prevracia data vo vektore (ako pri inverznom fourierovi)        */
 prevrat(d,N)
	float *d;
	int N;
  { int i1,i2;
	float pom;
	for(i1=1,i2=N-1;i1<i2;i1++,i2--)
	  {pom= *(d+i1);*(d+i1)= *(d+i2);*(d+i2)=pom;}
  }
/*-----------------------------------------------------------------*/
/* robi to iste ako "prevrat", ale v 2D poli pre vsetky vektory    */
 d2prevrat(d,vx,vy,smer)
	float *d[];
	int vx,vy,smer;
  { int i1,i2,j;
	float pom;
	if(smer==1){ /*po stlpcoch*/
			  for(j=0;j<vx;j++)
			   for(i1=1,i2=vy-1;i1<i2;i1++,i2--)
				{pom= *(d[i1]+j);*(d[i1]+j)= *(d[i2]+j);*(d[i2]+j)=pom;}}
		 else{ /*po riadkoch*/
			  for(j=0;j<vy;j++)
			   for(i1=1,i2=vx-1;i1<i2;i1++,i2--)
				{pom= *(d[j]+i1);*(d[j]+i1)= *(d[j]+i2);*(d[j]+i2)=pom;}}
 }
/*-----------------------------------------------------------------*/
/*bitova inverzia pre cele pole v x smere                          */
  bix(d,vx,vy)
	 float *d[];
	 unsigned int vx,vy;
	{static int i,j,inv[D1MAX];
	 static float pom[D1MAX];
	 prehod(inv,vx);
	 for(i=0;i<vy;i++){for(j=0;j<vx;j++) pom[j]= *(d[i]+inv[j]);
					   for(j=0;j<vx;j++) *(d[i]+j)=pom[j];}
	 }
/*-----------------------------------------------------------------*/
/*bitova inverzia pre cele pole v y smere                          */
  biy(d,vx,vy)
	 float *d[];
	 unsigned int vx,vy;
	{static int i,j,inv[D1MAX];
	 static float pom[D1MAX];
	 prehod(inv,vy);
	 for(j=0;j<vx;j++){for(i=0;i<vy;i++) pom[i]= *(d[inv[i]]+j);
					   for(i=0;i<vy;i++) *(d[i]+j)=pom[i];}
	 }

/*-----------------------------------------------------------------*/
/* vydeli cele pole cxislom vx*vy                                  */
 divide(d,vx,vy)
   float *d[];
   int vx,vy;
   {int i,j;
    float hod=(float)vx*vy;
    for(i=0;i<vy;i++)for(j=0;j<vx;j++) *(d[i]+j) = *(d[i]+j)/hod;
    }
