#include <stdio.h>
#include <math.h>
#include "simul.h"

extern prehod();
extern pis();
extern bitinv();
int   inv[D1MAX];
float msn[D1MAX],cs[D1MAX],sq2;
float rea[D1MAX],img[D1MAX];
/*----------------------------------------------------------------------------------------------------*/
furierko(rea,img,N,smer)
float rea[],img[];
int N,smer;
{int i,p,s,step,k;
 float pmr,pmi;
 if(smer== -1){prevrat(rea,N);prevrat(img,N);}
 bitinv(img,inv,N);
 bitinv(rea,inv,N);
	p=1;
	while(p<N){ s=0;
			   step=N/p;
			   while(s<N){for(i=s,k=0;i<s+p;i++,k+=step)
							  {pmr= rea[i+p]*cs[k]+img[i+p]*msn[k];
							   pmi= img[i+p]*cs[k]-rea[i+p]*msn[k];
							   rea[i+p]=rea[i]-pmr;
							   img[i+p]=img[i]-pmi;
							   rea[i]+=pmr;
							   img[i]+=pmi;}
						  s+=2*p;}
			   p*=2;}
}
/*----------------------------------------------------------------------------------------------------*/
cosinit(N)
int N;
{int i;
 prehod(inv,N);sq2=sqrt((double)2);
 for(i=0;i<N;i++){msn[i]= (float)sin(M_PI*(double)i/N);cs[i]= (float)cos(M_PI*(double)i/N);}
}
/*----------------------------------------------------------------------------------------------------*/
Ycos(d,vx,vy,smer)
	  float *d[];
	  int vx,vy,smer;
{int N=2*vy,i,j;
 cosinit(N);
 for(j=0;j<vx;j++)
   {for(i=0;i<N/2;i++){rea[i]= *(d[i]+j);img[i]=0;}
	for(i=N/2;i<N;i++){rea[i]=0;img[i]=0;}
	if(smer== -1){rea[0]= *(d[0]+j)/sq2;
				  for(i=1;i<N/2;i++){img[i]= rea[i] * msn[i];
									 rea[i]= rea[i] * cs[i];}
				  }
	furierko(rea,img,N,smer);
	if(smer==1){*(d[0]+j)=rea[0]/sq2;}else*(d[0]+j)=2*rea[0];
	for(i=1;i<N/2;i++)if(smer==1){*(d[i]+j)= (rea[i]*cs[i]+ img[i]*msn[i]);}
							  else *(d[i]+j)= 2*rea[i];
   }
 }
/*--------------------------------------------------------------------------------------------------------------------*/
Xcos(d,vx,vy,smer)
      float *d[];
      int vx,vy,smer;
{int N=2*vx,i,j;
 cosinit(N);
 for(j=0;j<vy;j++)
   {for(i=0;i<N/2;i++){rea[i]= *(d[j]+i);img[i]=0;};
    for(i=N/2;i<N;i++){rea[i]=0;img[i]=0;}
    if(smer== -1){rea[0]= *(d[j]+0)/sq2;
                  for(i=1;i<N/2;i++){img[i]= rea[i] * msn[i];
                                     rea[i]= rea[i]*cs[i];}
                  }                   
    furierko(rea,img,N,smer); 
    if(smer==1){*(d[j]+0)=rea[0]/sq2;}else*(d[j]+0)=2*rea[0]; 
    for(i=1;i<N/2;i++) if(smer==1){*(d[j]+i)= (rea[i]*cs[i]+ img[i]*msn[i]);}
                              else*(d[j]+i)=2*rea[i];
   }
 }   

