#include <math.h>
#include "simul.h"
extern float strvaltou();
extern float blgetjsm();
float mima();
typedef struct ratanie {long count;
			float val;} nepouzijem;

/*---------------------------------------------------------------------*/
mimo(rrr,actcount,val,hranica)
struct ratanie *rrr;
int *actcount,hranica;
float val;
{int a;
 for(a=0;a<*actcount;a++)
   if(rrr[a].val==val)
     {rrr[a].count++;break;}
 if(a== *actcount)
   {if(a>=hranica)
      {printf("prilis vela JSM urovni pri ratani entropie\n");
       printf("maximum %d \n",hranica);
       exit(1);}
    else
     {rrr[a].val=val;rrr[a].count=1;
      (*actcount)++;
      }
    }
 }
/*---------------------------------------------------------------------*/
void entrophy(d,vx,vy,zapis)
float *d[];
int vx,vy,zapis;
{ float *b[YMAX],pom;
  int i,j,blk,bx,by,jurovni,uroven,surovni;
  float ecount,myentrophy,scount;
  struct ratanie  rat[EUROVNI],rat2[EUROVNI];
  for(i=0;i<EUROVNI;i++)
	{ rat[i].count=rat[i].val=rat2[i].count=rat2[i].val=0;
	  }
  surovni=0;
  for(blk=0;blk<bl.numb;blk++)
    {blget(blk,d,b,&bx,&by);
     for(i=0;i<by;i++)
       for(j=0;j<bx;j++)
	 if(i|j) 
           {uroven=(int)strvaltou(*(b[i]+j));
            if(uroven>(int)EUROVNI)
	       {printf("prilis vela urovni va datach pri ratani entropie\n");
                printf("maximum %d aktualne %d \n",(int)EUROVNI,uroven);exit(1);}
	    if(surovni<uroven)surovni=uroven;
	       rat[uroven].val= *(b[i]+j);rat[uroven].count++;
	    } 
     }
 surovni++;
 jurovni=0;
 for(blk=0;blk<bl.numb;blk++)
   {pom=blgetjsm(blk,d);
    uroven=(int)strvaltou(pom);
    if(rat[uroven].val==pom) rat[uroven].count++;
    else mimo(rat2,&jurovni,pom,(int)EUROVNI);
    }
 ecount=0;
 for(i=0;i<surovni;i++)ecount+=rat[i].count;scount=ecount;
 for(i=0;i<jurovni;i++)ecount+=rat2[i].count;
 myentrophy=0;
 for(i=0;i<surovni;i++)
   if(rat[i].count)
     myentrophy-=(float)rat[i].count/ecount*log((float)rat[i].count/ecount)/log(2.0);
 for(i=0;i<jurovni;i++)
   if(rat2[i].count)
     myentrophy-=(float)rat2[i].count/ecount*log((float)rat2[i].count/ecount)/log(2.0);
 printf("ENROPIA JE %f (pocet str.zloziek %.0f, odlisnych JSM %.0f )\n"
         ,myentrophy,scount,ecount-scount);
 if(zapis==1)sim.entropia=myentrophy;
 }
/*---------------------------------------------------------------------*/

void logar(d,vx,vy)
 float *d[];
 int vx,vy;
 {int i,j;
  printf("LOGARITMUJEM VSTUPNY OBRAZOK\n");
  for(i=0;i<vx;i++)
    for(j=0;j<vy;j++)
       *(d[i]+j)=(float)log((double)*(d[i]+j)+1);
  vypis(d,vx,vy,"polog");
 }
/*---------------------------------------------------------------------*/
void expo(d,vx,vy)
 float *d[];
 int vx,vy;
 {int i,j;
 printf("OBRAZOK EXPONUJEM NAZAD\n"); 
 for(i=0;i<vx;i++)
   for(j=0;j<vy;j++)
     *(d[i]+j)=(float)exp((double)*(d[i]+j)) - 1;
 }

/*---------------------------------------------------------------------*/
float mima(d,vx,vy)
    float *d[];
    int vx,vy;
{int i,j;
 float mi,ma ;
 mi=0;ma=0;
   for(i=0;i<vy;i++)for(j=0;j<vx;j++) 
      if(i|j){if(*(d[i]+j)> ma ) ma= *(d[i]+j);
              if(*(d[i]+j)< mi ) mi= *(d[i]+j);}
 ma=(float)fabs(ma);
 mi=(float)fabs(mi);
 return((mi<ma) ? ma : mi);
 } 
/*-------------------------------------------------------------------------*/
do_cikcak(d,vx,vy,mxx,mxy,ampl,tvar,hran,rob,val)
    float *d[],ampl,tvar,hran,*val;
    int vx,vy,mxx,mxy,rob;
{  int x,y,dx,dy;
   float dialka,sign,max=0;
   srandom(random()%30000);
   x=vx-1;y=vy-1;
   dx= vx>vy ? vx/vy : 1;
   dy= vy>vx ? vy/vx : 1;
   dialka=0;
   while(dialka<hran)
      {if(rob==0)
             {/*rata vahovane maximum */
              if(max< fabs(*(d[y]+x) * 1/exp(dialka/tvar)))
                 max= fabs(*(d[y]+x) * 1/exp(dialka/tvar));
              }
       else
              {/* samotne rusenie */ 
               sign=(float)(random()%2);
               if(sign==0)sign= -1;
               *(d[y]+x)*=sign*(1+ (*val) *1/exp(dialka/tvar));
               };
      /*------------ vlastny algoritmus cik-cak ----------------*/
        if(vx==vy){cikcak_pom(vx,vy,&x,&y);}
        else if(vx>vy)if(x%dx){x--;}
                      else {x/=dx;cikcak_pom(vx/dx,vy,&x,&y);
                            x=x*dx+dx-1;}
             else  if(y%dy){y--;}
                    else {y/=dy;cikcak_pom(vx,vy/dy,&x,&y);
                          y=y*dy+dy-1;}
        dialka+=1;
       }
 if(rob==0) *val=max;
 }  
 /*--------------------------------------------------------------------------*/ 
cikcak_pom(vx,vy,x,y)
      int vx,vy,*x,*y;
  { static int smer;
    if(!(smer=(*x+*y)%2)) smer= -1;
             (*x)+=smer;(*y)-=smer;
             if((*y)<0){(*y)++;(*x)-=2;}
                 else if((*y)==vy){(*y)--;}
                     else if((*x)<0){(*x)++;(*y)-=2;}
                        else if((*x)==vx){(*x)--;};
   }
/*---------------------------------------------------------------------*/
pom_gauss(d,vx,vy,mxx,mxy,ampl,tvar,hran,rob,val)
    float *d[],ampl,tvar,hran,*val;
    int vx,vy,mxx,mxy,rob;
    {int a,b;
 float mocnina,dialka,sign,max=0;
 srandom(random()%30000);
 for(b=0;b<vy;b++)
   for(a=0;a<vx;a++)
     { mocnina=((mxx-a)*(mxx-a)+(mxy-b)*(mxy-b));
       dialka=(float)sqrt(mocnina);
       if(dialka<hran)
          {if(rob==0)
             {/*rata vahovane maximum */
              if(max< fabs(*(d[b]+a) * 1/exp(dialka/tvar)))
                 max= fabs(*(d[b]+a) * 1/exp(dialka/tvar));
              }
           else
              {/* samotne rusenie */ 
               sign=(float)(random()%2);
               if(sign==0)sign= -1;
               *(d[b]+a)*=sign*(1+ (*val) *1/exp(dialka/tvar));
               };
           }
       }
 if(rob==0) *val=max;
 }
/*------------------------------------------------------------------------*/
rus_cikcak(d,vx,vy)
    float *d[];
    int vx,vy;
{int mxx,mxy;
 float cmax,cmag,blokmax,ampl,tvar,hran;
 ampl=rus.campl;
 tvar=rus.ctvar/100*vx*vy;
 hran=rus.chran/100*vx*vy; 
 if(rus.campl==0)
   {cmag=1;
    do_cikcak(d,vx,vy,mxx,mxy,ampl,tvar,hran,1,&cmag);
    }
 else
   {do_cikcak(d,vx,vy,mxx,mxy,ampl,tvar,hran,0,&cmax);
    blokmax=mima(d,vx,vy);
    cmag=blokmax*ampl/cmax;
    do_cikcak(d,vx,vy,mxx,mxy,ampl,tvar,hran,1,&cmag);
    };
 }
/*------------------------------------------------------------------------*/
rus_gauss(d,vx,vy)
    float *d[];
    int vx,vy;
{int rcount,mxx,mxy;
 float gmax,gmag,blokmax,ampl,tvar,hran;
 for(rcount=0;rcount<rus.numgauss;rcount++)
    {mxx=rus.gpx[rcount];
     mxy=rus.gpy[rcount];
     ampl=rus.gampl[rcount];
     tvar=rus.gtvar[rcount];
     hran=rus.ghran[rcount]; 
    if(rus.gampl[rcount]==0)
       {gmag=1;
        pom_gauss(d,vx,vy,mxx,mxy,ampl,tvar,hran,1,&gmag);
        }
     else
       {pom_gauss(d,vx,vy,mxx,mxy,ampl,tvar,hran,0,&gmax);
        blokmax=mima(d,vx,vy);
        gmag=blokmax*ampl/gmax;
        pom_gauss(d,vx,vy,mxx,mxy,ampl,tvar,hran,1,&gmag);
        };
      };
 }
/*---------------------------------------------------------------------*/
zarus(d,vx,vy)
    float *d[];
    int vx,vy;
{float *b[YMAX];
 int blk,bx,by;
 bx=bl.bx;by=bl.by;
   for(blk=0;blk<bl.numb;blk++)
     {blget(blk,d,b,&bx,&by);
      if(rus.type==0)rus_gauss(b,bx,by);
      else rus_cikcak(b,bx,by);
      }
 }


