#include <math.h>
#include "simul.h"
extern float blgetjsm();
/*----------------------------------------------------------*/
float jsmvaltou(val)
float val;
{float u;
 u=floor((val-lq.jmin)/lq.jkr +0.5);
	if(u>=lq.ju)u=lq.ju-1;
	if(u<0)u=0;
 return(u);
 }
/*----------------------------------------------------------*/
float jsmutoval(u)
float u;
{return(u*lq.jkr+lq.jmin);
 }
/*----------------------------------------------------------*/
float strvaltou(val)
float val;
{float u;
 u=floor((val-lq.smin)/lq.skr +0.5);
 if(u>=lq.su)u=lq.su-1;
 if(u<0)u=0;
 return(u);
 }
/*----------------------------------------------------------*/
float strutoval(u)
float u;
{return(u*lq.skr+lq.smin);
 }
/*----------------------------------------------------------*/
pripis_str_kvant()
{pisfloat(lq.smin);
 pisfloat(lq.smax);
 pripis((long)lq.su,16);
 printf("pripisujem  str kvant ...\n");
}
/*----------------------------------------------------------*/
odpis_str_kvant()
{citajfloat(&lq.smin);
 citajfloat(&lq.smax);
 lq.su=(int)odpis(16);
 lq.skr=(lq.smax - lq.smin)/(lq.su-1) ;
 printf("odpisujem  str kvant...\n");
}
/*----------------------------------------------------------*/
pripis_jsm_kvant()
{pisfloat(lq.jmin);
 pisfloat(lq.jmax);
 pripis((long)lq.ju,16);
 printf("pripisujem  str kvant ...\n");
}
/*----------------------------------------------------------*/
odpis_jsm_kvant()
{citajfloat(&lq.jmin);
 citajfloat(&lq.jmax);
 lq.ju=(int)odpis(16);
 lq.jkr=(lq.jmax - lq.jmin)/(lq.ju-1) ;
 printf("odpisujem  jsm kvant...\n");
}
/*----------------------------------------------------------*/

save_oberg()
{int a;
 printf("save energ. koeficientov \n");
 for(a=0;a<bl.numb;a++)
	pisfloat(oberg.koef[a]);
 }
/*----------------------------------------------------------*/
load_oberg()
{int a;
 printf("load energ. koeficientov \n");
 for(a=0;a<bl.numb;a++)
	citajfloat(&oberg.koef[a]);
 }
/*----------------------------------------------------------*/
min_max(d,vx,vy,mi,ma)
	float *d[],*mi,*ma;
	int vx,vy;
{int i,j;
 for(i=0;i<vy;i++)for(j=0;j<vx;j++)
   if(i|j){if(*(d[i]+j)> *ma ) *ma= *(d[i]+j);
	   if(*(d[i]+j)< *mi ) *mi= *(d[i]+j);
           }
 }

/*----------------------------------------------------------*/
str_pole_kvant(d,vx,vy)
  float *d[];
  int vx,vy;
 {int i,j;
  if(lq.skr)
    for(i=0;i<vy;i++)
      for(j=0;j<vx;j++)
        if(i|j) *(d[i]+j)=lq.skr * floor(*(d[i]+j)/lq.skr +0.5);
   }
/*----------------------------------------------------------*/
kukuk(d,vx,vy)
  float *d[];
  int vx,vy;
 {int i,j;
  if(lq.skr)
    for(i=0;i<vy;i++)
      for(j=0;j<vx;j++)
        if(i|j) *(d[i]+j)=strvaltou(*(d[i]+j));
   }
/*----------------------------------------------------------*/
float one_jsm_kvant(pom)
 float pom;
{if(lq.jkr)return(lq.jmin+lq.jkr*floor((pom-lq.jmin)/lq.jkr+0.5));
 else return(pom);
 }
/*----------------------------------------------------------*/
init_str_quant(mi,ma)
float mi,ma;
{lq.skr=(ma-mi)/(lq.su-1);
 lq.smin=mi;lq.smax=ma;
 printf("Kvantizator str.zloziek: \n  min %f max %f krok %f urovni %d\n"
         ,lq.smin,lq.smax,lq.skr,lq.su);
 if(lq.skr)
   {lq.smin=lq.skr*floor(mi/lq.skr+0.5);
    lq.smax=lq.skr*floor(ma/lq.skr+0.5);
    printf("  upravene min %f max %f\n",lq.smin,lq.smax);
    }
 }
/*----------------------------------------------------------*/
init_jsm_quant(mi,ma)
float mi,ma;
{lq.jkr=(ma-mi)/(lq.ju-1);
 lq.jmin=mi;
 lq.jmax=ma;
 printf("Kvantizator JSM zloziek: \n  min %f max %f krok %f urovni %d\n"
         ,lq.jmin,lq.jmax,lq.jkr,lq.ju);
 
 }
/*----------------------------------------------------------*/
str_lin_kvant(d,vx,vy)
	float *d[];
	int vx,vy;
{float *b[YMAX],mi=0,ma=0;
 int blk,bx,by;
 for(blk=0;blk<bl.numb;blk++){blget(blk,d,b,&bx,&by);
                              min_max(b,bx,by,&mi,&ma);
			      }
 init_str_quant(mi,ma);
 for(blk=0;blk<bl.numb;blk++){blget(blk,d,b,&bx,&by);
                              str_pole_kvant(b,bx,by);
                              }
 printf("Striedave zlozky nakvantovane .\n");
 }
/*----------------------------------------------------------*/
jsm_lin_kvant(d,vx,vy)
	float *d[];
	int vx,vy;
{int blk ;
 float mi,ma,pom;
 mi=ma=blgetjsm(0,d);
 for(blk=1;blk<bl.numb;blk++){pom=blgetjsm(blk,d);
			      if(pom<mi)mi=pom;
	                      if(pom>ma)ma=pom;
		              }
 init_jsm_quant(mi,ma);
 for(blk=0;blk<bl.numb;blk++){pom=blgetjsm(blk,d);
			      pom=one_jsm_kvant(pom);
			      blputjsm(blk,d,pom);
			      }
 printf("Jednosmerne zlozky nakvantovane .\n");
 }
/*----------------------------------------------------------*/
nelin_kvant(d,vx,vy)
  float *d[];
  int vx,vy;
{ float *b[YMAX];
  int blk,bx,by;
  minit(bl.bx,bl.by);/*v tejto zjednodusenej verzii = rovnake vsetky bloky*/
  for(blk=0;blk<bl.numb;blk++)
	{blget(blk,d,b,&bx,&by);
	 mkvant(b,bx,by);
	 }
  }
/*----------------------------------------------------------*/
nelin_dekvant(d,vx,vy)
  float *d[];
  int vx,vy;
{ float *b[YMAX];
  int blk,bx,by;
  if(!rez.tam||(nlq.ako==2))
	minit(bl.bx,bl.by);/*init iba ked dekompresujem alebo filtrujem*/
  for(blk=0;blk<bl.numb;blk++)
	{blget(blk,d,b,&bx,&by);
	 mdekvant(b,bx,by);
	 }
  }






