#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include "simul.h"

extern float strvaltou();
extern float strutoval();


struct sled_data{int x,y;}sled[RMX][RMY],prvotne;

static float block_energy;
struct m_perc { long pocitadlo;
				long hranica ;}pe;
struct m_energ{ float pocitadlo;
				float hranica;}en;
struct m_nuly { long pocitadlo;
				long hranica ;}nu;
struct m_back { long pocitadlo;
				long hranica ;}ba;
void rezcikcak();
void rezrovno();
void rezuzivatelsky();
void rezwav();
void rezwan();
void rezwah();
void r0init();
void r2init();
void energ_begin();
void perc_begin();
void nenul_begin();
void back_begin();
int back_podm();
int perc_podm();
int energ_podm();
int nenul_podm();
/*-------------------------------------------------------------------*/
initrez()
{switch(rez.typ){case(0): rez.rez= rezcikcak;rez.init=r0init;break;
		 case(1): rez.rez= rezrovno;rez.init=r0init;break;
		 case(2): rez.rez= rezuzivatelsky;rez.init=r2init;break;
		 case(3): printf("Waveletove rezanie standardne ...\n");
                          rez.rez= rezwav;rez.init=r0init;break;
                 case(4): rez.rez= rezwan;rez.init=r0init;break;
                 case(5): rez.rez= rezwah;rez.init=r0init;break;
                 default:printf("zly typ rezania \n");exit(1);
                 }
 }
/*-------------------------------------------------------------------*/
initmethod()
   {if(rez.tam)
    {switch(rez.method)
     {case(0): met.podm=perc_podm;met.begin=perc_begin;
	       printf("Zadaj kolko percent rezat percmax,percmin,perckrok: ");
               break;
      case(1): met.podm=energ_podm;met.begin=energ_begin;
	       printf("Zadaj kolko %% energie odrezat emax,emin,ekrok: ");
               break;
      case(2): met.podm=nenul_podm;met.begin=nenul_begin;
	       printf("Zadaj na kolkom nenulovom zastavit rezanie bmax,bmin,bkrok: ");
               break;
      default: printf(" .... taku zatial nepoznam \n");exit(1); }
      fflush(stdout);
     }
    else{printf("-------------rezanie nazad ----------\n");
         met.podm=back_podm;
         met.begin=back_begin;}  
   }
/*-------------------------------------------------------------------*/  
/*kvantuje urovne pre huffmana */ 
 vloz(blk,poradie,hodnota)
      float hodnota;
      int blk;
      long poradie;
   {int pom;
    pom=(int)strvaltou(hodnota);
    *(bl.data[blk]+poradie)=pom;
   }
/*-------------------------------------------------------------------*/  
/*dekvantuje urovne z huffmana */ 
 float vyber(blk,poradie)
      int blk;
      long poradie;
   {float u= *(bl.data[blk]+poradie);
	return(strutoval(u));
    }   
/*-------------------------------------------------------------------*/
rataj_energy(b,vx,vy)
    float *b[];
    int vx,vy;
{int x,y;
 if(rez.method==1 || oberg.robit==1)
   if (rez.tam)
     {en.pocitadlo=0;
      block_energy=0;
      for(x=0;x<vx;x++)
        for(y=0;y<vy;y++)
          if(x|y) block_energy+=fabs(*(b[y]+x)); 
      }
 }
/*-------------------------------------------------------------------*/
void perc_begin(blk,b,vx,vy)
    float *b[];
    int vx,vy,blk;
{if(oberg.robit==1) rataj_energy(b,vx,vy);
 pe.pocitadlo=0;
 pe.hranica=((long)vx*vy-1)*met.cykl/100;
}
/*-------------------------------------------------------------------*/
void energ_begin(blk,b,vx,vy)
    float *b[];
    int vx,vy,blk;
{rataj_energy(b,vx,vy);
 en.pocitadlo=0;
 en.hranica=block_energy*met.cykl/100;
 }
/*------------------------------------------------------------------*/
void nenul_begin(blk,b,vx,vy)
    float *b[];
    int vx,vy,blk;
{if(oberg.robit==1) rataj_energy(b,vx,vy);
 nu.pocitadlo=0;
 nu.hranica=met.cykl;}
 /*------------------------------------------------------------------*/
void back_begin(blk,b,vx,vy)
    float *b[];
    int vx,vy,blk;
{ba.pocitadlo=0;
 ba.hranica=vx*vy-bl.ldata[blk];}
/*------------------------------------------------------------------*/
int back_podm(b,x,y)
    float *b[];
    int x,y;
{ba.pocitadlo++;
 if(ba.pocitadlo<ba.hranica) return(0);
  else{ /*printf("podmienka splnena , hranica bola %d\n",pe.hranica);*/
       return(1);}
 }
/*------------------------------------------------------------------*/
int perc_podm(b,x,y)
    float *b[];
    int x,y;
{if(pe.pocitadlo<pe.hranica)
        {if(oberg.robit==1)en.pocitadlo+= fabs(*(b[y]+x));
         pe.pocitadlo++;
         return(0) ;} 
  else{/*printf("podmienka splnena , hranica bola %d\n",pe.hranica);*/
        return(1);}
 }
/*------------------------------------------------------------------*/
int energ_podm(b,x,y)
    float *b[];
    int x,y;
{if(en.pocitadlo<en.hranica)
   {en.pocitadlo += fabs(*(b[y]+x));return(0);} 
  else{return(1);}
 }
/*------------------------------------------------------------------*/
int nenul_podm(b,x,y)
    float *b[];
    int x,y;
{if(*(b[y]+x)!=0)nu.pocitadlo++;
 if(nu.pocitadlo<nu.hranica) 
     {if(oberg.robit==1)en.pocitadlo+= fabs(*(b[y]+x));
      return(0);
      }        
 else {
 /*printf("nenul podmienka splnena , hranica bola %d\n",nu.hranica);*/
       return(1);
       }
 }
/*------------------------------------------------------------------*/
void initglob(blk,count)
 int blk;
 long count;
 {if(rez.tam)
    {if(!(bl.data[blk] = ( int *) calloc ( count,sizeof(int))))
             {printf("chyba pri alokacii\n");exit(1);};
	 bl.ldata[blk]=count-1;
	 if(oberg.robit && (block_energy-en.pocitadlo))
	   {oberg.koef[blk]=block_energy/(block_energy-en.pocitadlo);
            /* printf("celkova %f orezana %f koef %f \n",
	    block_energy,en.pocitadlo,oberg.koef[blk]);*/
	    }
	 else oberg.koef[blk]=1;
	 }

  else{/* ak dekodujem obrazok netreba robit nic */;
	  }
  }
/*-----------------------------------------------------------------------------------*/
void r0init(vx,vy,x,y)
int vx,vy,*x,*y;
{ *x = vx-1;
  *y = vy-1;
  }
/*-----------------------------------------------------------------------------------*/
void r2init(vx,vy,x,y)
int vx,vy,*x,*y;
{ *x = prvotne.x;
  *y = prvotne.y;
  }

/*-----------------------------------------------------------------------------------*/
 rezblok(d,blk,vx,vy)
    float *d[];
    int vx,vy,blk;
  {long count;
   int neorezane,x,y;
   (met.begin)(blk,d,vx,vy);
    count=vx*vy;
    neorezane=1;
    (rez.init)(vx,vy,&x,&y);
   while(count>1)
      {if(neorezane)
	 {if( (met.podm)(d,x,y) )
	     {neorezane=0;
	      initglob(blk,count);
	      }
	  else *(d[y]+x)=0.0;
	  }
       if(!neorezane)
	  {if(rez.tam){ vloz(blk,count-2, *(d[y]+x) );
			if(oberg.robit) *(d[y]+x) *= oberg.koef[blk] ;
                       }
	   else{ *(d[y]+x)=vyber(blk,count-2);
                  if(oberg.robit) *(d[y]+x)= *(d[y]+x) * oberg.koef[blk];
                  }
           }
       (rez.rez)(vx,vy,&x,&y);
        count--;
        }
  if(neorezane)bl.ldata[blk]=0;
 }  

/*------------------------------------------------------------------------------*/
void rezwav(vx,vy,x,y)
int vx,vy,*x,*y;
{static int actblx,actbly,hrxd,hrxh,hryd,hryh,hrblx,hrbly;
 if( (*x==(vx-1)) && (*y==(vy-1)) )
   {/* zaciatok rezania, zisti pocet blokov atd ... */
    hrblx=floor(log((float)vx)/log(2.0)+0.5)+1;
    hrbly=floor(log((float)vy)/log(2.0)+0.5)+1;
    actblx=hrblx-1;
    actbly=hrbly-1;
    hrxd=vx/2;hrxh=vx;
    hryd=vy/2;hryh=vy;
    };
if(--(*x) <hrxd)
   {if(--(*y)>=hryd) (*x)=hrxh-1;
    else 
     {/* novy blok */
      rezcikcak(hrblx,hrbly,&actblx,&actbly);
      hrxh=floor(exp((float)actblx*log(2.0))+0.5);hrxd=hrxh/2;
      hryh=floor(exp((float)actbly*log(2.0))+0.5);hryd=hryh/2;
      (*x)=hrxh-1;(*y)=hryh-1;
      };
    }
 /*printf("KON:actblx%d actbly%d hrxd%d hrxh%d hryd%d hryh%d hrblx%d hrbly%d X%d Y%d vx%d vy %d\n",actblx,actbly,hrxd,hrxh,hryd,hryh,hrblx,hrbly,*x,*y,vx,vy);  */
  }  
/*------------------------------------------------------------------------------*/
void rezwan(vx,vy,x,y)
int vx,vy,*x,*y;
{static int actblx,actbly,hrxd,hrxh,hryd,hryh,hrblx,hrbly;
 if( (*x==(vx-1)) && (*y==(vy-1)) )
   {/* zaciatok rezania, zisti pocet blokov atd ... */
    printf("ZACIATOK WAN...................................\n");
    hrxd=vx/2;hrxh=vx;
    hryd=vy/2;hryh=vy;
    };
if(--(*x) <hrxd)
   {if(--(*y)>=hryd) (*x)=hrxh-1;
    else 
     { /* novy blok */
      if( ((*x)>=0) && ((*y)>=0) )
         {hrxd=0;hrxh/=2;}
      if((*x)==-1)
        {hrxd=hrxh;hrxh=2*hrxd;
         hryh=hryd;hryd=0;
         }
     if((*y)==-1)
        {hrxh=hrxd;hrxd=hrxd/2;
         hryd=hryh/2;
         }
      (*x)=hrxh-1;(*y)=hryh-1;
      };
    }
 }  
/*------------------------------------------------------------------------------*/
void rezwah(vx,vy,x,y)
int vx,vy,*x,*y;
{if(--(*x) < 0)
   {if(--(*y)>=0) (*x)=vx-1;
    else { printf(" MIMO rozsah rezania  ...\n");exit(0);}
    };
 }  
/*------------------------------------------------------------------------------*/
void pomcikcak(vx,vy,x,y)
 int vx,vy,*x,*y;
  { static int smer;
    if(!(smer=(*x+*y)%2)) smer= -1;
    (*x)+=smer;(*y)-=smer;
    if((*y)<0){(*y)++;(*x)-=2;}
    else if((*y)==vy){(*y)--;}
	 else if((*x)<0){(*x)++;(*y)-=2;}
	      else if((*x)==vx){(*x)--;};
   }
/*------------------------------------------------------------------------------*/
void rezcikcak(vx,vy,x,y)
 int vx,vy,*x,*y;    
 {int dx,dy;
  dx= vx>vy ? vx/vy : 1;
  dy= vy>vx ? vy/vx : 1;
  if(vx==vy){pomcikcak(vx,vy,x,y);}
  else if(vx>vy)if((*x)%dx){(*x)--;}
                else {(*x)/=dx;pomcikcak(vx/dx,vy,x,y);
                      (*x)=(*x)*dx+dx-1;}
       else     if((*y)%dy){(*y)--;}
                else {(*y)/=dy;pomcikcak(vx,vy/dy,x,y);
                      (*y)=(*y)*dy+dy-1;}
 }
/*----------------------------------------------------------------------------*/
void   pomrovno(vx,vy,x,y)
  int vx,vy,*x,*y;
  {if((*y)>=(*x))
	 {(*x)--;
	  if((*x)<0)
		{(*y)--;(*x)=(*y)+1;}
	  }
   else
	 {(*y)--;
	  if((*y)<0)
		{(*x)--;(*y)=(*x);}
	  };
   }
/*------------------------------------------------------------------------------*/
void rezrovno(vx,vy,x,y)
 int vx,vy,*x,*y;    
 {int dx,dy;
  dx= vx>vy ? vx/vy : 1;
  dy= vy>vx ? vy/vx : 1;
  if(vx==vy){pomrovno(vx,vy,x,y);}
  else if(vx>vy)if((*x)%dx){(*x)--;}
                else {(*x)/=dx;pomrovno(vx/dx,vy,x,y);
                      (*x)=(*x)*dx+dx-1;}
       else     if((*y)%dy){(*y)--;}
                else {(*y)/=dy;pomrovno(vx,vy/dy,x,y);
                      (*y)=(*y)*dy+dy-1;}
 }
/*----------------------------------((*y)+1)*dx-------------------------------------*/
void   rezuzivatelsky(vx,vy,x,y)
  int vx,vy,*x,*y;
 {int a;
  a=sled[(*x)][(*y)].x;
  (*y)=sled[(*x)][(*y)].y;
  (*x)=a;
   }
/*-----------------------------------------------------------------------------------*/
void m2citaj(kam,kolko)
 int *kam,*kolko;
{char *subor=rez.m2name;
 FILE *vstup;
 int i,hranica=RMX*RMY;
 int cislo;
 if(!(vstup = fopen(subor,"r")))
   {printf("Neviem najst subor s nacitavacou maticou:%s!\n",subor);
	exit(1);};
 i=0;
 while((fscanf(vstup,"%d",&cislo)!=EOF)&&(i<hranica))
   {kam[i]=cislo;
    i++;
    }
 *kolko=i;
 fclose(vstup);
 }

/*-----------------------------------------------------------------------------------*/
void hladaj(mtr,pocet,co,kde)
int *mtr,pocet,co,*kde;
{int a;
 for(a=0;a<pocet;a++)
   if(mtr[a]==co)
	  {*kde=a;break;}
 }
/*-----------------------------------------------------------------------------------*/
void inittyp2rez(bx,by)
int bx,by;
{int a,pocet,kde,old,prve;
 int mtr[RMX*RMY];
 if((bx>RMX)||(by>RMY))
  {printf("prilis velky blok na tento sposob rezania");exit(1);}
 m2citaj(mtr,&pocet);
 if(pocet!=bx*by)
   {printf("velkost nacitavacej matice: %d sa nezhoduje s velkostou bloku: %dx%d\n",
            pocet,bx,by);
    exit(1);
    }
 for(a=1;a<=pocet;a++)
   {hladaj(mtr,pocet,a,&kde);
	if(a==1){old=kde;prve=kde;}
	else
	  {sled[old%bx][old/bx].x=kde%bx;
	   sled[old%bx][old/bx].y=kde/bx;
	   old=kde;
	   }
	}
 prvotne.x=sled[old/bx][old%bx].x= prve%bx;
 prvotne.y=sled[old/bx][old%bx].y= prve/bx;
 }
/*-----------------------------------------------------------------------------------*/
void rez_nacit(d,vx,vy)
  float *d[];
  int vx,vy;
{ float *b[YMAX];
  int blk,bx,by;
  if(rez.typ==2)
	inittyp2rez(bl.bx,bl.by);
  for(blk=0;blk<bl.numb;blk++)
    {blget(blk,d,b,&bx,&by);
     rezblok(b,blk,bx,by);
     }
   printf("spektrum orezane a nacitane\n");
  }
