#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include "simul.h"
struct huffman {struct huffman *lavy,*pravy;
	       long pocetnost;
	       unsigned int bitcount;
	       unsigned long hufcode;
	       unsigned int  hodnota;
	       } *huf[2*HUROVNI],*riad[HUROVNI],*min1p,*min2p;
struct prijem {struct prijem *lavy,*pravy;
                unsigned char koniec;
                unsigned int hodnota;} *prj[2*HUROVNI];
long node;
unsigned char *rlbuf,*bitrov;
int *hufcisla,vb,decurovni;
long rlptr,bitptr;
/*#########################################################################*/
pis_rl_var()
{pripis((long)pred.rl_sl,8);
 pripis((long)pred.rl_huf,8);
 }
/*#########################################################################*/
odpis_rl_var()
{pred.rl_sl=(int)odpis(8);
 pred.rl_huf=(int)odpis(8);
 }
/*-----------------------------------------------------------------------------------*/
int rlcitaj_prvok(prvok)
    struct prijem *prvok;
{int a,b;
  if(!prvok->koniec){a=(int)rlodpis(rlbuf,&rlptr,1);
                     if(a){b=rlcitaj_prvok(prvok->pravy);}
                     else{b=rlcitaj_prvok(prvok->lavy);};
                    }
  else b=prvok->hodnota;
 return(b);
 }
/*-----------------------------------------*/
 rlcitaj_strom(prvok)
   struct prijem *prvok;
 {static long stav;
  stav=(long)rlodpis(rlbuf,&rlptr,1); 
  if(stav==1){node++;prvok->pravy=prj[node];rlcitaj_strom(prj[node]); 
              node++;prvok->lavy=prj[node];rlcitaj_strom(prj[node]);
              }
      else   {prvok->hodnota=(int)rlodpis(rlbuf,&rlptr,vb);
              prvok->koniec=1;
              }                            
  }
/*#########################################################################*/
rlodpis_strom()
{ int i;
  long ptr1=rlptr;
  printf("pri odpisovani stromu rlptr %d \n",rlptr);
  decurovni=(int)rlodpis(rlbuf,&rlptr,16);
  vb=(int)rlodpis(rlbuf,&rlptr,4);
  printf("strom ma %d urovni kodovanych %d bitmi\n",decurovni,(int)vb);
  for(i=0;i<(decurovni*2-1);i++){prj[i] =(struct prijem * ) calloc(1,sizeof(struct prijem));
                              prj[i]->koniec=0;}
  node=0;
  rlcitaj_strom(prj[0]); 
 printf("strom potreboval %d bitov\n",rlptr-ptr1);
 }
/*#########################################################################*/

 rlpripis(mybuf,myptr,slovo,dlzka)
 unsigned char *mybuf;
 long *myptr;
 unsigned long slovo;
 unsigned char dlzka;
   {unsigned long maska=1;
    long pracptr= *myptr;
    maska=maska<<(dlzka-1);
    while(maska){if(maska & slovo){*(mybuf+pracptr/8)+=1<<(pracptr%8);};
                 pracptr++;
                 maska/=2; 
                 } 
    *myptr=pracptr;
    }
/*#########################################################################*/
rlodpis(mybuf,myptr,dlzka) 
 unsigned char *mybuf;
 long *myptr;
 unsigned char dlzka;
{long slovo;
 long pracptr= *myptr;
 unsigned long maska=1;
 maska=maska<<(dlzka-1);
 slovo=0;
 while(maska){if(*(mybuf+pracptr/8) & 1<<(pracptr%8)){slovo+=maska;};
              pracptr++;
              maska/=2;
             }
 *myptr=pracptr; 
 return(slovo);
}
/*#########################################################################*/
int binexp(cislo)
int cislo;
{return((int)floor(0.5+exp((double)cislo*log((double)2))));}
/*#########################################################################*/
 rlvypis(slovo,dlzka)
 unsigned long slovo;
 unsigned int dlzka;
   {unsigned long maska=1;
    maska=maska<<(dlzka-1);
    while(maska){if(maska & slovo)printf("1");
		 else printf("0");
		 maska/=2;
                 } 
    }

/*##################################################################*/
rlhinit(urovni)
 int urovni;
{int i;
 for(i=0;i<(urovni*2-1);i++)
     {if(!(huf[i] =(struct huffman * ) calloc(1,sizeof(struct huffman))))
           {printf("do riti,je malo pamate ... \n");exit(1);};
      huf[i]->lavy=0;huf[i]->pravy=0;
      huf[i]->pocetnost=0;huf[i]->bitcount=0;
      huf[i]->hufcode=0;huf[i]->hodnota=i;}
}
/*##################################################################*/
static dekoduj(prvok,kod,size)
        struct huffman *prvok;
         unsigned long kod;
         unsigned char size;
   {if((prvok->pravy) || (prvok->lavy))
      {rlpripis(rlbuf,&rlptr,1,1);
       dekoduj(prvok->pravy,2*kod+1,size+1);
       dekoduj(prvok->lavy,2*kod,size+1);
       }
    else{prvok->bitcount=size;prvok->hufcode=kod;
         rlpripis(rlbuf,&rlptr,0,1);rlpripis(rlbuf,&rlptr,prvok->hodnota,vb);
         }
         }

/*#########################################################################*/
rlstrom(redukcia,urovni)
  int redukcia,urovni;
{ int min1,min2,i,vyslem=0,k,node=urovni;
  for(i=0;i<urovni;i++)if(huf[i]->pocetnost || !redukcia){riad[i]=huf[i];}
		       else riad[i]=0;
  for(i=0;i<urovni;i++)if(riad[i]){vyslem++;};
do{
  k=0;
  for(i=0;i<urovni;i++)
      if(riad[i])
	 {min1=i;k++;};
  if(k>1)
     {for(i=0;i<urovni;i++)
	 if(riad[i])if(riad[i]->pocetnost<riad[min1]->pocetnost)min1=i;
      min1p=riad[min1];riad[min1]=0;
      for(i=0;i<urovni;i++)if(riad[i]){min2=i;break;};
      for(i=0;i<urovni;i++)
	 if(riad[i])if(riad[i]->pocetnost<riad[min2]->pocetnost)min2=i;
      min2p=riad[min2];riad[min2]=huf[node];node++;
      riad[min2]->pocetnost=min1p->pocetnost + min2p->pocetnost;
      if(min1<min2){riad[min2]->pravy=min1p;riad[min2]->lavy=min2p;}
	       else{riad[min2]->pravy=min2p;riad[min2]->lavy=min1p;}
     }
  }
while(k>1);
 vb=pocbit(urovni); 
 printf("pred pripisanim stromu vyslem=%d vb=%d rlptr=%d\n",vyslem,vb,rlptr);
 rlpripis(rlbuf,&rlptr,(long)vyslem,16);
 rlpripis(rlbuf,&rlptr,(long)vb,4);
 dekoduj(riad[min2],(long)0,(int)0);
 }

/*********************************************/
rlkoduj(vstbuf,insize,vystbuf,outsize)
unsigned char *vstbuf,*vystbuf;
int insize;     /*mal by byt long !!!*/
long *outsize;
{int a;
 long inpt=0,outpt=0;
 int count=0,stav=0,hranica=binexp(pred.rl_sl)-1;
 unsigned char slbit=pred.rl_sl;
 /*hranica max pocet rovnakych symbolov (pre tabulku);*/
 printf("HRANICA velkosti bloku je %d insize je %d\n",hranica,insize);
 for(a=0;a<insize;a++)   
  {if(stav==rlodpis(vstbuf,&inpt,1))
     {if(count==hranica)   
	{rlpripis(vystbuf,&outpt,count,slbit);
	 count=0;
         rlpripis(vystbuf,&outpt,count,slbit);
	 }
      count++; 
      }
   else {rlpripis(vystbuf,&outpt,count,slbit);
         if(stav)stav=0;else stav=1;
	 count=1;
	 };
   }
 if(count)rlpripis(vystbuf,&outpt,count,slbit); 
 *outsize=outpt;
 }
/*********************************************/
rldekoduj(vstbuf,insize,vystbuf,outsize)
unsigned char *vstbuf,*vystbuf;
long insize;     /*mal by byt long !!!*/
long *outsize;
{long a,b;
 long inpt=0,outpt=0;
 int count,stav=0,pocet=pred.rl_sl;
 for(a=0;a<insize;a++)   
  {count=rlodpis(vstbuf,&inpt,pocet);
   for(b=0;b<count;b++)
     rlpripis(vystbuf,&outpt,stav,1);
   stav=1-stav;
   }
 *outsize=outpt;
 }

/*********************************************/
rlpis(mybuf,myptr,robit)
 unsigned char *mybuf;
 long myptr;
 int robit;
{long dac,dummy;
 if (robit)
    {printf("datove pole ma %d prvkov a je taketo:\n",myptr);
     for(dac=0;dac<myptr;dac++) 
       {dummy=dac;
        printf(" %d",rlodpis(mybuf,&dummy,1));
        }
     printf("\n");
     }
 }
/*********************************************/
rl_tam(d,vx,vy)
float *d[];
int vx,vy;
{long myptr,hufpol,ppp;
 float rlbitbod;
 int *hufcisla,hufurovni,a,b;
 rlbuf= (unsigned char *) calloc ((long)vx*vy+1,1 );
 bitrov=(unsigned char *) calloc ( (long)vx*vy/8+1,1);
 bitptr=0;
 printf("--------------------------------\n");
 printf("ROBIM R-L +HUFFMAN CODING ......\n");
 for(a=0;a<vy;a++)
   for(b=0;b<vx;b++)
     if(*(d[a]+b)>=128){rlpripis(bitrov,&bitptr,1,1);*(d[a]+b)-=128;}
     else rlpripis(bitrov,&bitptr,0,1);
 printf("bitova rovina zabera %d bitov\n",bitptr);
 /*88888888888888888888888*/
 rlptr=0;
 rlkoduj(bitrov,bitptr,rlbuf,&rlptr);
 printf("R-L kod ma %d bitov \n",rlptr);
 
 /* Huffmanova cast */
 hufcisla=(int *) calloc ((rlptr/pred.rl_huf+10),sizeof(int) );
 hufpol=0;myptr=0;
 /*data z rl buffra prepisem ako cisla z daneho intervalu pre huffmanov kod */
 while(myptr<rlptr)
   {hufcisla[hufpol]= rlodpis(rlbuf,&myptr,pred.rl_huf);
    /*printf("cislo %d je %d \n",hufpol,hufcisla[hufpol]);*/
    hufpol++;}
 printf("Huffmanovych koeficientov bude %d\n",hufpol);
 hufurovni=binexp(pred.rl_huf);
 printf("huffman bude mat %d urovni \n",hufurovni);

 rlhinit(hufurovni);
 /* teraz treba zratat pocetnosti hufpol cisel */
 for(a=0;a<hufpol;a++)
   huf[hufcisla[a]]->pocetnost++;
 printf("zratane pocetnosti\n");
/* for(a=0;a<hufurovni;a++)
   printf("uroven %d ma %d\n",a,huf[a]->pocetnost);*/
 /* potom vytvorit huffmanov kod , a vysledky pripisat rovno do cmp suboru , alebo do vlastneho */
 rlptr=0;
 for(ppp=0;ppp<(long)vx*vy+1;ppp++)*(rlbuf+ppp)=0;
 rlstrom(1,hufurovni);
 /*for(a=0;a<hufurovni;a++)
   printf("cislo %d ma kod %d na %dbitov\n",a,huf[a]->hufcode,huf[a]->bitcount);
   */ 
 for(a=0;a<hufpol;a++)
   rlpripis(rlbuf,&rlptr,huf[hufcisla[a]]->hufcode,huf[hufcisla[a]]->bitcount);

if(comp.rob)
   {printf(" pred :comp ptr je %d \n",comp.ptr);
    pis_rl_var();pripis((long)rlptr,20);pripis((long)hufpol,20);
    printf(" medzi:comp ptr je %d \n",comp.ptr);
    myptr=0;
    bitcopy(rlbuf,&myptr,comp.buf,&comp.ptr,rlptr);
    printf(" po :comp ptr je %d \n",comp.ptr); 
    }
 rlbitbod=(float)rlptr/(vx*vy);
 sim.BnB+=rlbitbod;sim.ctcbnb=rlbitbod;
 printf("Bit na bod pridane r-l codom je %f\n",rlbitbod);
 free(hufcisla);
 free(rlbuf);
 }
/***************************************************************/
void rl_spat(d,vx,vy)
float *d[];
int vx,vy;
{int a,b;
 long dummy=0;
 /*rlpis(bitrov,vx*vy,1);*/
 for(a=0;a<vy;a++)
   for(b=0;b<vx;b++)
     *(d[a]+b)+= 128*rlodpis(bitrov,&dummy,1);
 free(bitrov);
 }
/***************************************************************/
void back_rl(d,vx,vy)
float *d[];
int vx,vy;
{long rlnum,rlptr,hufpol,ppp,bitptr=0;
 int i;
 rlbuf= (unsigned char *) calloc ((long) vx *vy +1,1);
 bitrov=(unsigned char *) calloc ((long)( vx *vy)/8+1,1 );
 
 printf(" pred :comp ptr je %d \n",comp.ptr);
 odpis_rl_var();rlnum=(long)odpis(20);hufpol=(long)odpis(20);
 printf(" medzi:comp ptr je %d \n",comp.ptr);
 bitcopy(comp.buf,&comp.ptr,rlbuf,&rlptr,rlnum);
 printf(" po :comp ptr je %d \n",comp.ptr); 
 rlptr=0;
 rlodpis_strom(); 
 printf("strom odpisany\n");
 printf("huffmanovych vzoriek je %d\n",hufpol);
 hufcisla=(int *) calloc ( hufpol+10 ,sizeof(int) );
 for(i=0;i<hufpol;i++)
    hufcisla[i]=rlcitaj_prvok(prj[0]);
 for(ppp=0;ppp<(long)vx*vy+1;ppp++)*(rlbuf+ppp)=0;
 rlptr=0;
 for(i=0;i<hufpol;i++)  
   rlpripis(rlbuf,&rlptr,(long)hufcisla[i],pred.rl_huf);
 printf("pri RL-dekodovani som zaplnill buffer az po %d \n",rlptr);
 rldekoduj(rlbuf,rlptr,bitrov,&bitptr);
 free(hufcisla);
 free(rlbuf);
 }

  
 
