#include <math.h>
#include <malloc.h>
#include "simul.h"

extern float blgetjsm();
extern float jsmvaltou();
 long pole;
 int v_b; /* pocet bitov, ktorymi sa koduju prvky v strome */
 struct huffman {struct huffman *lavy,*pravy;
			   long pocetnost;
			   unsigned char bitcount;
			   unsigned long hufcode;
			   unsigned int  hodnota;
			   } *huf[2*HUROVNI],*riad[HUROVNI],*min1p,*min2p;
/*##################################################################*/
static dekoduj(prvok,kod,size)
		struct huffman *prvok;
		 unsigned long kod;
		 unsigned char size;
   {if((prvok->pravy) || (prvok->lavy))
	  {pripis(1,1);
	   dekoduj(prvok->pravy,2*kod+1,size+1);
	   dekoduj(prvok->lavy,2*kod,size+1);
	   }
	else{prvok->bitcount=size;prvok->hufcode=kod;
		 pripis(0,1);pripis(prvok->hodnota,v_b);
		 }
         }
/*##################################################################*/
hinit(urovni)
 int urovni;
{int i;
 for(i=0;i<(urovni*2-1);i++)
     {if(!(huf[i] =(struct huffman * ) calloc(1,sizeof(struct huffman))))
           {printf("do riti,je malo pamate ... \n");exit(1);};
      huf[i]->lavy=0;huf[i]->pravy=0;
      huf[i]->pocetnost=0;huf[i]->bitcount=0;
      huf[i]->hufcode=0;huf[i]->hodnota=i;}
}
/*#######################################################################*/
hznic(urovni)
 int urovni;
{int i;for(i=0;i<(urovni*2-1);i++) free(huf[i]);}
/*########################################################################*/
 jsmpis1(d,vx,vy)
 float *d[];
 int vx,vy;
 {float jspom;
  int blk;
  long ptr1=comp.ptr;
  printf("jsm kodovanie bez huffmana...\n"); 
  printf("comp.ptr je %d\n",comp.ptr);
  pripis(0,1);                  /*robim kodovanie bez HUFFIHO */ 
  for(blk=0;blk<bl.numb;blk++)
     {jspom=blgetjsm(blk,d);
      pisfloat(jspom);
      }
  printf("Jsm zlozky pripisane v %d bitoch\n",comp.ptr-ptr1);
  printf("comp.ptr je %d\n",comp.ptr);
   }
/*#########################################################################*/
jsmpis2(d,vx,vy)
 float *d[];
 int vx,vy;
{int  blk,jsmbits;
 long ptr1 ;
 float *jsp,maxd1,maxd2,pom;
 pripis(1,1);                         /*robim kodovanie s HUFFMANOM */
 jsp=(float *) calloc (bl.numb,sizeof(float));           /* ALOKACIA */
 for(blk=0;blk<bl.numb;blk++)
   {pom=blgetjsm(blk,d);
    *(jsp+blk)=jsmvaltou(pom);
    }
 ptr1=comp.ptr;
 pripis_jsm_kvant();
 maxd1=maxd2=0;
 for(blk=bl.numb-1;blk>0;blk--)
   {pom = *(jsp+blk) -= *(jsp+blk-1);
    if(pom>maxd1)maxd1= pom;
    if(pom<maxd2)maxd2= pom;
    }
 for(blk=bl.numb-1;blk>0;blk--)*(jsp+blk)-=maxd2;
 jsmbits=pocbit((long)floor(maxd1-maxd2));
 printf("maxhore=%d maxdole=%d bits=%d prva je %d\n",
         (long)maxd1,(long)maxd2,(long)jsmbits,(long)*(jsp+0));
 pripis((long)*(jsp+0),20);
 pripis((long)-maxd2,10);
 hinit((long)floor(maxd1-maxd2+1));
 for(blk=1;blk<bl.numb;blk++)
   huf[(long)( *(jsp+blk) )]->pocetnost++;
 strom(1,(long)floor(maxd1-maxd2+1));
 for(blk=1;blk<bl.numb;blk++)
   {pripis(huf[(long)( *(jsp+blk) )]->hufcode,
    huf[(long)( *(jsp+blk) )]->bitcount);
    }
 hznic((long)floor(maxd1-maxd2+1));
 printf("jsm zlozky zakodovane v %d bitoch(komplet )\n",comp.ptr-ptr1);
 printf("comp.ptr je %d\n",comp.ptr);
 free(jsp);
 /*exit(1);*/
 }
/*#####################################################################*/
strom(redukcia,urovni)
  int redukcia,urovni;
{ int min1,min2,i,vyslem=0,k,node=urovni;
  long ptr1=comp.ptr;
  for(i=0;i<urovni;i++)if(huf[i]->pocetnost || !redukcia){riad[i]=huf[i];}
                       else riad[i]=0;
  for(i=0;i<urovni;i++)if(riad[i]){vyslem++;};    
do{
  k=0;
  for(i=0;i<urovni;i++)
      if(riad[i])
         {min1=i;k++;};
  if(k>1)
     {for(i=0;i<urovni;i++)
         if(riad[i])if(riad[i]->pocetnost<riad[min1]->pocetnost)min1=i;
	  min1p=riad[min1];riad[min1]=0;
      for(i=0;i<urovni;i++)if(riad[i]){min2=i;break;};
      for(i=0;i<urovni;i++)
         if(riad[i])if(riad[i]->pocetnost<riad[min2]->pocetnost)min2=i;     
      min2p=riad[min2];riad[min2]=huf[node];node++;
      riad[min2]->pocetnost=min1p->pocetnost + min2p->pocetnost;
      if(min1<min2){riad[min2]->pravy=min1p;riad[min2]->lavy=min2p;}
               else{riad[min2]->pravy=min2p;riad[min2]->lavy=min1p;}
     }
  } 
while(k>1);
v_b=pocbit(urovni);
printf("v strome budu urovne kodovane %d bitmi\n",v_b);

pripis((long)vyslem,16);
pripis((long)v_b,4);

dekoduj(riad[min2],0,0);
printf("velkost stromu je %d bitov\n",comp.ptr-ptr1);
 }
/*#################################################################################*/
koduj_spektrum(d,vx,vy)
 float *d[];
 int vx,vy;
{  int blk,urovni,i;
   float bit_bod,odhad,suma;
   long hc,count=0,ptr1;
   if(!comp.rob)
     {printf("Kodovanie huffmanovym kodom nerobim.\n");return ;}
   printf("--------------- Kodovanie spektra --------------------\n");
   if((lq.jrob)&&((int)BLHUFMIN<=bl.numb))
     {jsmpis2(d,vx,vy); /* Huffmanom*/}
   else{jsmpis1(d,vx,vy);        /* bez Huffmana*/ }
   printf("------------ striedave zlozky --------------\n");
   urovni=lq.su;
   hinit(urovni+1);
   for(blk=0;blk<bl.numb;blk++)
     {for(hc=0;hc<bl.ldata[blk];hc++)
	{i= *(bl.data[blk]+hc);
	 huf[i]->pocetnost++;
         }
      }
   odhad=0;suma=(float)vx*vy-bl.numb;
   for(i=0;i<urovni;i++)
    if(huf[i]->pocetnost)
     odhad-=(float)huf[i]->pocetnost/suma*log((float)huf[i]->pocetnost/suma)/log(2.0);
   huf[(urovni)]->pocetnost+=bl.numb;
   urovni++;   /* + jedna uroven na koniec bloku */
   printf("urovni je %d\n",urovni);
   strom(1,urovni);ptr1=comp.ptr;
   printf("comp.ptr je %d\n",comp.ptr);
   pripis((long)(urovni-1),v_b);   /*zastavovaci znak*/
   for(blk=0;blk<bl.numb;blk++)
     {for(hc=0;hc<bl.ldata[blk];hc++)
	{i= *(bl.data[blk]+hc);
	pripis(huf[i]->hufcode,huf[i]->bitcount);
	count++;
	}
   pripis(huf[(urovni-1)]->hufcode,huf[(urovni-1)]->bitcount);
   };printf("comp.ptr je %d\n",comp.ptr);
   
   odhad=odhad*count/suma;
   bit_bod=(float)comp.ptr/(vx*vy);
   sim.BnB =bit_bod;sim.odhadbnb=odhad;
   sim.shufbnb=((float)comp.ptr-ptr1)/suma;
   printf("%d str. zloziek zakodovanych v %d bitoch \n",
           count,comp.ptr-ptr1);
   printf("Efektivita huffmanovho kodovania je %f\n",sim.shufbnb);
   printf("pricom teoreticke minimum je %f bit/zlozka\n",odhad);
   printf("<<< Celkova kompresia je %f bit/bod .>>>\n",sim.BnB);
   hznic(urovni);
printf("--------------------------------------------------------------------------\n");
}