/* vstup/vystup pre cely program*/
#include <malloc.h>
#include <math.h>
#include "simul.h"
/*----------------------------------------------------------------------------*/
     nacitaj(d,vx,vy,subor)
     float *d[];
     char *subor;
     unsigned int vx,vy;
    {  long  nread,fp1,picx,picy;
       int fd1,i,j;
       unsigned char buf[D1MAX];
       fd1=open(subor,0);
       if(fd1 == -1)
               {printf("chyba vstupneho dat. suboru %s \n ",subor);
                exit(1);}
       fp1=lseek(fd1,0L,0);nread=read(fd1,buf,4);
       picx=buf[0]+256*buf[1];picy=buf[2]+256*buf[3];
       printf("obrazok je typu %d * %d (x*y) ... ",picx,picy);
       for(i=0;i<vy;i++){fp1=lseek(fd1,4+picx*i,0);
                         (nread = read(fd1,buf,vx));
                         for(j=0;j<vx;j++) *(d[i]+j)=buf[j];}        
       close(fd1);
       printf("Data nacitane \n");
   }; 
/*------------------------------------------------------------------------*/
int pis_float_spectrum(d,vx,vy,popis)
float *d[];
int vx,vy;
char *popis;
{FILE *myfile;
 char subor[NLEN];
 int a,b;
 if(proc.pis)
   {sprintf(subor,"sp%s%s%s.flo",trdef.txabr,trdef.tyabr,popis);
    if(proc.chname)uprav(subor);
    if ((myfile = fopen(subor, "wb")) == NULL)
      {fprintf(stderr, "Nemozem otvorit subor. %s\n",subor);
       return 1;
       }
    fwrite(&vx, sizeof(float), 1, myfile);
    fwrite(&vy, sizeof(float), 1, myfile);
    for(a=0;a<vy;a++)
      for(b=0;b<vx;b++)
        fwrite((d[a]+b), sizeof(float), 1, myfile);
    fclose(myfile);
    printf("float spektrum zapisane do suboru: %s \n",subor);
    }
 return 0;
 }
/*------------------------------------------------------------------------*/
int cit_float_spectrum(d,vx,vy,subor)
float *d[];
int vx,vy;
char *subor;
{FILE *myfile;
 int a,b,xx,yy;
 if ((myfile = fopen(subor, "rb"))== NULL)
   {fprintf(stderr, "Nemozem otvorit subor.\n");
    return 1;
    }
 fread(&xx, sizeof(float), 1, myfile);
 fread(&yy, sizeof(float), 1, myfile);
 printf("Float pole ma velkost %d x %d \n",xx,yy);
 for(a=0;a<vy;a++)
   for(b=0;b<vx;b++)
     if(fread((d[a]+b), sizeof(float), 1, myfile)==0)
       {fprintf(stderr, "Nemozem precitat polozku.\n");
	return 1;
	}
     else {printf("c %f",*(d[a]+b));
	   }
 fclose(myfile);
 printf("spektrum precitane z %s . \n",subor);
 return 0;
 }

 /*-----------------------------------------------------------------------------*/
vypisspektrum(d,vx,vy,popis)
      float *d[];
      unsigned int vx,vy;
      char *popis;
    { float *s[YMAX],*p[YMAX],*b[YMAX],max;
      char subor[NLEN];
      int blk,bx,by;
      int typ,i,j;
      if(proc.pis)
        {vytvor(s,vx,vy); max=0;
        for(typ=0;typ<3;typ++)
         {for(blk=0;blk<bl.numb;blk++)
           {blget(blk,d,b,&bx,&by);
            blget(blk,s,p,&bx,&by);
             for(i=0;i<by;i++)
              for(j=0;j<bx;j++)
               if(i|j)switch(typ)
                      {case 0:if(fabs(*(b[i]+j))>max ) max =fabs(*(b[i]+j));break;
                       case 1:*(p[i]+j)= 255*fabs(*(b[i]+j))/max;break;                  
                       case 2:*(p[i]+j)=255*(log(fabs(*(b[i]+j))+1))/log(max+1); 
                       }
                 else if(typ) *(p[i]+j)=255;
            } 
          if(typ)
            {if(typ==1)sprintf(subor,"splin%s%s%s.pic",trdef.txabr,trdef.tyabr,popis);
             if(typ==2)sprintf(subor,"splog%s%s%s.pic",trdef.txabr,trdef.tyabr,popis);
             vypis(s,vx,vy,subor);
             }
          }
          vymaz(s,vx,vy);
        } ;
 }
/*-----------------------------------------------------------------------------*/
vypismatrix(d,vx,vy,popis)
      float *d[];
      unsigned int vx,vy;
      char *popis;
    { float *s[YMAX], max;
      char subor[NLEN];
       int typ,i,j;
      if(proc.pis)
        {vytvor(s,vx,vy); max=0;
         for(typ=0;typ<3;typ++)
          { for(i=0;i<vy;i++)
              for(j=0;j<vx;j++)
                if(i|j)switch(typ)
                      {case 0:if(fabs(*(d[i]+j))>max ) max =fabs(*(d[i]+j));break;
                       case 1:*(s[i]+j)= 255*fabs(*(d[i]+j))/max;break;                  
                       case 2:*(s[i]+j)=255*(log(fabs(*(d[i]+j))+1))/log(max+1); 
                       }
                else if(typ) *(s[i]+j)=255;
            if(typ)
            {if(typ==1)sprintf(subor,"splin%s%s%s.pic",trdef.txabr,trdef.tyabr,popis);
             if(typ==2)sprintf(subor,"splog%s%s%s.pic",trdef.txabr,trdef.tyabr,popis);
             vypis(s,vx,vy,subor);
             } 
          }         
        vymaz(s,vx,vy); 
       };
}               
/*-----------------------------------------------------------------------------*/
 uprav(co)
 char *co;
{char buf[NLEN];
 sprintf(buf,"%d%s",sim.count,co);
 strcpy(co,buf);
 }
/*-----------------------------------------------------------------------------*/ 
 vypis(d,vx,vy,subor)
      float *d[];
      char *subor;
      unsigned int vx,vy;
    {  long   nwrite,fp2;
       int fd2,i,j;
       char vystsubor[NLEN];
       unsigned char buf[D1MAX];
       if(proc.pis)
         {strcpy(vystsubor,subor);
          if(proc.chname)uprav(vystsubor);
          fd2=creat(vystsubor,0644);close(fd2);fd2=open(vystsubor,1);
          if(fd2 == -1){ perror("chyba vyst. dat. suboru");exit(1);}
          buf[1]=vx/256;buf[0]=vx%256;buf[3]=vy/256;buf[2]=vy%256;
          fp2=lseek(fd2,0L,0);nwrite=write(fd2,buf,4);      
          for(i=0;i<vy;i++)
             {for(j=0;j<vx;j++) 
                 if(*(d[i]+j)>=0 && *(d[i]+j)<=255)
                                   {buf[j]= *(d[i]+j);}
                 else if(*(d[i]+j)<0){buf[j]=0;}
                      else if(*(d[i]+j)>255){buf[j]=255;}                                           
              nwrite=write(fd2,buf,vx);}       
          close(fd2); 
          printf("data vypisane do suboru %s\n",vystsubor);
          if(proc.show){switch(proc.pid[proc.poc_proc]=fork())
                       {case -1:printf("chyba pri spusteni procesu ...\n");exit(1);
                        case 0: execl("show","show",vystsubor,0);exit(3);};
                        printf("vytvoreny proces s id %d\n",proc.pid[proc.poc_proc]);proc.poc_proc++;
                        }
          };
     }
/*-----------------------------------------------------------------------------*/ 
pis_bit_subor(outbuf,bufptr,subor)
unsigned char *outbuf;
long bufptr;
char *subor;
{if(proc.pis)
   {if(proc.chname)uprav(subor);
    low_pis_bit_sub(outbuf,bufptr,subor);
    }; 
 }
/*-----------------------------------------------------------------------------*/
low_pis_bit_sub(outbuf,bufptr,subor)
unsigned char *outbuf;
long bufptr;
char *subor;
{int fd;
 long fp,nwrite;
 fd=creat(subor,0600);close(fd);
 fd=open(subor,1);
 if(fd == -1){ perror("chyba vyst. dat. suboru ");exit(1);}
 fp=lseek(fd,0L,0);nwrite=write(fd,outbuf,(bufptr-1)/8+1); 
 printf("bit. data vypisane do '%s' velkeho %d bitov,co je %d bytov\n",subor,bufptr,(bufptr-1)/8+1);     
 close(fd);
}
/*-----------------------------------------------------------------------------*/
long cit_bit_subor(citbuf,subor)
unsigned char **citbuf;
char *subor;
{int fd ;
 long fp,nread,velkost;
  fd=open(subor,0);
  if(fd== -1){ perror("chyba vst. bit. dat. suboru  " );exit(1);}
  velkost=lseek(fd,0L,2);
  fp=lseek(fd,0L,0);
  if(!(*citbuf=(unsigned char *) calloc (velkost,1)))
          {printf("neda sa alokovat ...");exit(2);}
  printf("data citam zo suboru:%s velkeho %d bytov ...",subor,velkost); 
  nread=read(fd,*citbuf,velkost);printf("OK %d bytov \n",nread); 
  close(fd);
  return(velkost);
  }